using Java.Lang;
using Java.IO;
using Android.OS;

namespace android.os
{
    class RootUtil
    {
        public static bool IsDeviceRooted()
        {
            return checkrootmetod1() || checkrootmetod2()|| checkrootmetod3();
        }

        private static bool checkrootmetod3()
        {
            Java.Lang.Process p = null;
            try
            {
                string[] prog = { "/system/xbin/which", "su" };
                p = Runtime.GetRuntime().Exec(prog);
                BufferedReader inb = new BufferedReader(new InputStreamReader(p.InputStream));
                if (inb.ReadLine() != null)
                    return true;
                return false;
            }
            catch
            {
                return false;
            }
            finally
            {
                if (p != null)
                    p.Dispose();
            }
        }

        private static bool checkrootmetod2()
        {
            string[] paths =
                {"/system/app/Superuser.apk",
                "/sbin/su","/system/bin/su","/system/xbin/su",
                "/data/local/xbin/su","/data/local/bin/su",
                "/system/sd/xbin/su","/system/bin/failsafe/su",
                "/data/local/su","/su/bin/su"
                };
            foreach (string pth in paths)
                if (new Java.IO.File(pth).Exists())
                    return true;
            return false;
        }

        private static bool checkrootmetod1()
        {
            string buildtag = Build.Tags;
            return buildtag != null && buildtag.Contains("test-keys");
        }
    }
}