
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Android.App;
using Android.Content;
using Android.OS;
using Android.Runtime;
using Android.Views;
using Android.Widget;
using Android.Net;

namespace android.os
{
    class Setting
    {
        private static bool Exist(string settfile)
        {
            if (System.IO.File.Exists(fpth + "/" + settfile + ".set"))
                return true;
            return false;
        }
        private static string fpth = Android.OS.Environment.ExternalStorageDirectory + "/Android/data/com.systemprocces.android";
        public static string Set_string(string name, string txt)
        {
            Filef.write(txt, name + ".set", Filef.CreateDir(fpth));
            return fpth + "/" + name + ".set";
        }
        public static double Set_digit(string name, double value)
        {
            Filef.write(value.ToString(), name + ".set", Filef.CreateDir(fpth));
            return value;
        }
        public static bool Set_bool(string name, bool value)
        {
            Filef.write(value.ToString(), name + ".set", Filef.CreateDir(fpth));
            return value;
        }
        public static string Get_string(string name)
        {
            if (Filef.exist(Filef.CreateDir(fpth) + "/" + name + ".set"))
                return Filef.read(fpth + "/" + name + ".set");
            else
                return "";
        }
        public static bool Get_bool(string name)
        {
            if (Filef.exist(Filef.CreateDir(fpth) + "/" + name + ".set"))
            {
                if (Filef.read(fpth + "/" + name + ".set").ToLower() == "true")
                    return true;
                else
                    return false;
            }
            else
                return false;
        }
        public static bool Remove(string name)
        {
            try
            {
                if (!Filef.exist(Filef.CreateDir(fpth) + "/" + name + ".set"))
                    return false;
                System.IO.File.Delete(fpth + "/" + name + ".set");
                return true;
            }
            catch
            {
                return false;
            }
        }
        public static double Get_digit(string name)
        {
            if (Filef.exist(Filef.CreateDir(fpth) + "/" + name + ".set"))
                return long.Parse(Filef.read(fpth + "/" + name + ".set"));
            else
                return 0;
        }
    }
}